'From etoys4.0 of 9 October 2008 [latest update: #2237] on 4 August 2009 at 12:32:50 am'!

!ObjectWithDocumentation methodsFor: 'accessing' stamp: 'KR 7/30/2009 00:10'!
helpMessage
	"Check if there is a getterSetterHelpMessage. 
	Otherwise try the normal help message or return nil."

	^ self getterSetterHelpMessage
		ifNil: [(self propertyAt: #helpMessage ifAbsent:
			[self legacyHelpMessage ifNil: [^ nil]]) translatedWithContext: 'EtoysHelpString']! !

!ObjectWithDocumentation methodsFor: 'accessing' stamp: 'KR 7/30/2009 00:17'!
wording
	"Answer the receiver's wording"

	| wording |
	(wording := self propertyAt: #wording ifAbsent: [nil])
		ifNotNil: [^wording translatedWithContext: 'EtoysVoca'].

	self initWordingAndDocumentation.
	^self propertyAt: #wording ifAbsent: ['']! !

!ObjectWithDocumentation methodsFor: 'private' stamp: 'KR 7/31/2009 00:55'!
getterSetterHelpMessage
	"Returns a helpMessage that has been computed previously and needs to be translated and then formatted with the elementSymbol.
	'get value of {1}' translated format: {elSym}"

	^((self propertyAt: #getterSetterHelpMessage ifAbsent: [^nil])
		translatedWithContext: 'EtoysHelpString') format: {self elementSymbol}! !


!TileMorph methodsFor: 'accessing' stamp: 'KR 7/30/2009 01:03'!
options
	"Answer the options of the tile for an arrow"
	(type == #literal
			and: [literal isKindOf: Boolean])
		ifTrue: [^ {{true. false}. #('true' 'false' ) translatedNoopWithContext: 'EtoysVoca'}].
	operatorOrExpression
		ifNil: [^ nil].
	(ScriptingSystem arithmeticalOperatorsAndHelpStrings first includes: operatorOrExpression)
		ifTrue: [^ ScriptingSystem arithmeticalOperatorsAndHelpStrings].
	(ScriptingSystem numericComparitorsAndHelpStrings first includes: operatorOrExpression)
		ifTrue: [self receiverType = #Number
				ifTrue: [^ ScriptingSystem numericComparitorsAndHelpStrings]
				ifFalse: [^ #(#(#= #~=) #('equal' 'not equal')) translatedNoopWithContext: 'EtoysVoca' ]].
	^ nil! !

!TileMorph methodsFor: 'mouse handling' stamp: 'KR 7/30/2009 12:43'!
showOptions
	"The receiver is a tile that represents an operator; a click on the 
	receiver's label will pop up a menu of alternative operator choices"
	| result menuChoices word |
	menuChoices _ (self options first collect: [:each | each asString]) collect: [:each | 
							word := self currentVocabulary translatedWordingFor: each asSymbol.
							word isEmpty
								ifTrue: ['<-']
								ifFalse: [word]].
	result _ (SelectionMenu labelList: menuChoices lines: nil selections: self options first) startUp.
	result 
		ifNotNil: [self value: result.
			self scriptEdited]! !


!UpdatingStringMorph methodsFor: 'target access' stamp: 'KR 7/30/2009 12:40'!
acceptValueFromTarget: v
	"Accept a value from the target"

	lastValue _ v.
	self format == #string ifTrue: [^ v asString].
	self format == #symbol ifTrue: [^ v asString fromCamelCase translatedWithContext: 'EtoysVoca'].
	(format == #default and: [v isNumber]) ifTrue:
		[^ self stringForNumericValue: v].
	^ v printString translated! !

