'From etoys4.0 of 9 October 2008 [latest update: #2237] on 4 August 2009 at 12:32:54 am'!

!GetTextExporter2 methodsFor: 'private' stamp: 'KR 7/29/2009 23:21'!
appendVocabularies: domains
	| literalsForDomain contexts references domainName |
	
	EToyVocabulary allPhrasesWithContextToTranslate do: [ :r |
		domainName _ self getTextDomainForClassCategory: r first.
		literalsForDomain _ domains at: domainName ifAbsentPut: [Dictionary new].
		r fourth do: [ :tuple |
			| literal msgctxt |
			literal _ tuple first.
			msgctxt _ tuple second.
			contexts _ literalsForDomain at: literal ifAbsentPut: [Dictionary new].
			references _ contexts  at: msgctxt ifAbsentPut: [OrderedCollection new].
			references add: (MethodReference new setStandardClass: (r second)
													methodSymbol: (r third)).
		].
	]. 
	! !


!Morph class methodsFor: 'scripting' stamp: 'KR 7/30/2009 13:33'!
helpContributions
	"Answer a list of pairs of the form (<symbol> <help message> ) to contribute to the system help dictionary"
	
"NB: Many of the items here are not needed any more since they're specified as part of command definitions now.  Someone needs to take the time to go through the list and remove items no longer needed.  But who's got that kind of time?"

	^ #(
		(acceptScript:for:
			'submit the contents of the given script editor as the code defining the given selector')
		(actorState
			'return the ActorState object for the receiver, creating it if necessary')
		(addInstanceVariable
			'start the interaction for adding a new variable to the object')
		(addPlayerMenuItemsTo:hand:
			'add player-specific menu items to the given menu, on behalf of the given hand.  At present, these are only commands relating to the turtle')
		(addYesNoToHand
			'Press here to tear off a  TEST/YES/NO unit which you can drop into your script')
		(allScriptEditors
			'answer a list off the extant ScriptEditors for the receiver')
		(amount
			'The amount of displacement')
		(angle	
			'The angular displacement')
		(anonymousScriptEditorFor:
			'answer a new ScriptEditor object to serve as the place for scripting an anonymous (unnamed, unsaved) script for the receiver')
		(append:
			'add an object to this container')
		(prepend:
			'add an object to this container')
		(assignDecrGetter:setter:amt:
			'evaluate the decrement variant of assignment')
		(assignGetter:setter:amt:
			'evaluate the vanilla variant of assignment')
		(assignIncrGetter:setter:amt:
			'evalute the increment version of assignment')
		(assignMultGetter:setter:amt:
			'evaluate the multiplicative version of assignment')
		(assureEventHandlerRepresentsStatus
			'make certain that the event handler associated with my current costume is set up to conform to my current script-status')
		(assureExternalName
			'If I do not currently have an external name assigned, get one now')
		(assureUniClass
			'make certain that I am a member a uniclass (i.e. a unique subclass); if I am not, create one now and become me into an instance of it')
		(availableCostumeNames
			'answer a list of strings representing the names of all costumes currently available for me')
		(availableCostumesForArrows
			'answer a list of actual, instantiated costumes for me, which can be cycled through as the user hits a next-costume or previous-costume button in a viewer')
		(beep:
			'make the specified sound')
		(borderColor
			'The color of the object''s border')
		(borderWidth
			'The width of the object''s border')
		(bottom
			'My bottom edge, measured downward from the top edge of the world')
		(bounce:
			'If object strayed beyond the boundaries of its container, make it reflect back into it, making the specified noise while doing so.')
		(bounce
			'If object strayed beyond the boundaries of its container, make it reflect back into it')
		(chooseTrigger
'When this script should run.
"normal" means "only when called"')
		(clearTurtleTrails
			'Clear all the pen trails in the interior.')
		(clearOwnersPenTrails
			'Clear all the pen trails in my container.')
		(color	
			'The object''s interior color')
		(colorSees
			'Whether a given color in the object is over another given color')
		(colorUnder
			'The color under the center of the object')
		(copy
			'Return a new object that is very much like this one')
		(cursor	
			'The index of the chosen element')
		(deleteCard
			'Delete the current card.')
		(dismiss
			'Click here to dismiss me')
		(doMenuItem:
			'Do a menu item, the same way as if it were chosen manually')
		(doScript:
			'Perform the given script once, on the next tick.')
		(elementNumber
			'My element number as seen by my owner')
		(fire
			'Run any and all button-firing scripts of this object')
		(firstPage
			'Go to first page of book')
		(followPath
				'Retrace the path the object has memorized, if any.')
		(forward:
			'Moves the object forward in the direction it is heading') 
		(goto:
			'Go to the specfied book page')
		(goToNextCardInStack
			'Go to the next card')
		(goToPreviousCardInStack
			'Go to the previous card.')
		(goToRightOf:
			'Align the object just to the right of any specified object.')
		(heading
			'Which direction the object is facing.  0 is straight up') 
		(height	
			'The distance between the top and bottom edges of the object')
		(hide
			'Make the object so that it does not display and cannot handle input')
		(initiatePainting	
			'Initiate painting of a new object in the standard playfield.')
		(initiatePaintingIn:
			'Initiate painting of a new object in the given place.')
		(isOverColor
			'Whether any part of this object is directly over the specified color')
		(isUnderMouse
			'Whether any part of this object is beneath the current mouse-cursor position')
		(lastPage
			'Go to the last page of the book.')
		(left
			'My left edge, measured from the left edge of the World')
		(leftRight
			'The horizontal displacement')
		(liftAllPens
			'Lift the pens on all the objects in my interior.')
		(lowerAllPens
			'Lower the pens on all the objects in my interior.')
		(mouseX
			'The x coordinate of the mouse pointer')
		(mouseY
			'The y coordinate of the mouse pointer')
		(moveToward:
			'Move in the direction of another object.')
		(insertCard
			'Create a new card.')
		(nextPage
			'Go to next page.')
		(numberAtCursor
			'The number held by the object at the chosen element')
		(objectNameInHalo
			'Object''s name -- To change: click here, edit, hit ENTER')
		(obtrudes
			'Whether any part of the object sticks out beyond its container''s borders')
		(offerScriptorMenu
			'The Scriptee.
Press here to get a menu')
		(pauseScript:
			'Make a running script become paused.')
		(penDown
			'Whether the object''s pen is down (true) or up (false)')
		(penColor
			'The color of the object''s pen')
		(penSize	
			'The size of the object''s pen')
		(clearPenTrails
			'Clear all pen trails in the current playfield')
		(playerSeeingColorPhrase
			'The player who "sees" a given color')
		(previousPage
			'Go to previous page')

		(show
			'If object was hidden, make it show itself again.')
		(startScript:
			'Make a script start running.')
		(stopScript:
			'Make a script stop running.')
		(top
			'My top edge, measured downward from the top edge of the world')
		(right
			'My right edge, measured from the left edge of the world')
		(roundUpStrays
			'Bring all out-of-container subparts back into view.')
		(scaleFactor
			'The amount by which the object is scaled')
		(stopScript:
			'make the specified script stop running')
		(tellAllSiblings:
			'send a message to all of my sibling instances')
		(try
			'Run this command once.' )
		(tryMe
			'Click here to run this script once; hold button down to run repeatedly'  )
		(turn:				
			'Change the heading of the object by the specified amount')
		(unhideHiddenObjects
			'Unhide all hidden objects.')
		(upDown
			'The vertical displacement')
		(userScript
			'This is a script defined by you.')
		(userSlot
			'This is a variable defined by you.  Click here to change its type')
		(valueAtCursor
			'The chosen element')
		(wearCostumeOf:
			'Wear the same kind of costume as the other object')
		(width	
			'The distance between the left and right edges of the object')
		(wrap
			'If object has strayed beond the boundaries of its container, make it reappear from the opposite edge.')
		(x
			'The x coordinate, measured from the left of the container')
		(y
			'The y-coordinate, measured upward from the bottom of the container')

		) translatedNoopWithContext: 'EtoysHelpString'
! !


!StandardScriptingSystem methodsFor: 'help dictionary' stamp: 'KR 7/30/2009 13:37'!
helpStringOrNilFor: aSymbol 
	"If my HelpStrings dictionary has an entry at the given symbol, 
	answer that entry's value, else answer nil"
	HelpStrings
		at: aSymbol
		ifPresent:[:string | ^ string translatedWithContext: 'EtoysHelpString'].
^ nil! !

!StandardScriptingSystem methodsFor: 'utilities' stamp: 'KR 8/3/2009 13:01'!
arithmeticalOperatorsAndHelpStrings
	"Answer an array consisting of lists of the standard arithmetical operator tiles and of the corresponding balloon help for them"

	^ #((+ - * / // \\ max: min:)
	 	('add' 'subtract' 'multiply' 'divide' 'divide & truncate' 'remainder when divided by' 'larger value' 'smaller value' )) translatedNoopWithContext: 'EtoysHelpString'! !

!StandardScriptingSystem methodsFor: 'utilities' stamp: 'KR 7/30/2009 12:28'!
helpStringOrNilForOperator: anOperator
	"Answer the help string associated with the given operator, nil if none found."

	| anIndex opsAndHelp |
	(anIndex _ (opsAndHelp _ self arithmeticalOperatorsAndHelpStrings) first indexOf: anOperator) > 0
		ifTrue:	[^ (opsAndHelp second at: anIndex) translatedWithContext: 'EtoysHelpString'].

	(anIndex _ (opsAndHelp _ self numericComparitorsAndHelpStrings) first indexOf: anOperator) > 0
		ifTrue:	[^ (opsAndHelp second at: anIndex) translatedWithContext: 'EtoysHelpString'].

	(anIndex _ (opsAndHelp _ self numericFunctionsAndHelpStrings) first indexOf: anOperator) > 0
		ifTrue:	[^ (opsAndHelp second at: anIndex) translatedWithContext: 'EtoysHelpString'].

	^ nil! !

!StandardScriptingSystem methodsFor: 'utilities' stamp: 'KR 8/3/2009 13:01'!
numericComparitorsAndHelpStrings
	"Answer an array whose first element is the list of comparitors, and whose second element is a list of the corresponding help strings"

	^ #((< <= = ~= > >= isDivisibleBy:)
	 	('less than' 'less than or equal' 'equal' 'not equal' 'greater than' 'greater than or equal' 'divisible by' )) translatedNoopWithContext: 'EtoysHelpString'! !

!StandardScriptingSystem methodsFor: 'utilities' stamp: 'KR 8/3/2009 13:05'!
tableOfNumericFunctions
	"Answer an array of <external function name> <actual function to call> <help string> triplets."

"		English on tile			selector				English balloon help"
	^ #(
		(abs 					abs						'absolute value')
		(arcTan				arcTan				'angle, in radians, whose tangent is the argument')
		(cos					cos						'trigonometric cosine, argument in radians')
		(cube					cubed					'the argument times itself, times itself again')
		(cubeRoot				cubeRoot				'cube root of the argument')
		(degreeArcTan		degreeArcTan		'angle, in degrees, whose tangent is the argument')
		(degreeCos				degreeCos				'trigonometric cosine, argument in degrees')
		(degreeSin				degreeSin				'trignometric sine, argument in degrees')
		(degreeTan			degreeTan				'trigonometric tangent, argument in degrees')

		(degreesToRadians	degreesToRadians	'the number of degrees equivalent to the argument which is assumed to be expressed in radians')
		(exp					exp					'exponential (e to the power of the argument)')
		(factorial				safeFactorial				'the product of all the whole numbers between 1 and the argument')
		(ln						safeLn					'natural logarithm')
		(log						safeLog				'logarithm, base 10')
		(negate 			negated				'the negative of the argument')
		(radiansToDegrees	radiansToDegrees	'the number of radians equivalent to the argument, which is expressed in degrees.')
		(random				random				'a randomly chosen integer between 1 and the argument')
		(round					rounded				'the integer closest to the argument.')
		(sign					sign					'1 if argument is positive, -1 if argument is negative, 0 if argument is zero.')
		(sin						sin						'trigonometric sine, argument in radians')
		(square				squared				'the argument multiplied by itself')
		(squareRoot			safeSquareRoot		'square root of the argument')
		(tan					tan						'trigonometric tangent, argument in radians')
		(truncate				truncated				'the integer nearest to the argument toward zero')

			) translatedNoopWithContext: 'EtoysHelpString'


"
		(raisedto 		raisedTo:		'raised to the power')   
"! !


!Vocabulary methodsFor: 'translation' stamp: 'KR 7/30/2009 01:11'!
translatedWordingFor: aSymbol
	"If I have a translated wording for aSymbol, return it, else return aSymbol.  Caveat: at present, this mechanism is only germane for *assignment-operator wordings* and the special-case numeric comparitor #isDivisibleBy:"

	#(: Incr: Decr: Mult: isDivisibleBy:)  
		with: (#('' 'increase by' 'decrease by' 'multiply by' 'divisible by')  translatedNoopWithContext: 'EtoysVoca')  do:
				[:a :b | aSymbol = a ifTrue: [^ b translated]].

	^ aSymbol fromCamelCase translatedWithContext: 'EtoysVoca'! !


!Vocabulary class methodsFor: 'class initialization' stamp: 'KR 7/30/2009 01:08'!
initializeStandardVocabularies
	"Initialize a few standard vocabularies and place them in the AllStandardVocabularies list."

	AllStandardVocabularies _ nil.

	self addStandardVocabulary: EToyVocabulary new.
	self addStandardVocabulary: EToyVectorVocabulary new.

	self addStandardVocabulary: self newPublicVocabulary.
	self addStandardVocabulary: FullVocabulary new.

	self addStandardVocabulary: self newQuadVocabulary.

	self addStandardVocabulary: ColorType new.
	self addStandardVocabulary: BooleanType new.
	self addStandardVocabulary: GraphicType new.
	self addStandardVocabulary: PlayerType new.
	self addStandardVocabulary: SoundType new.
	self addStandardVocabulary: StringType new.
	self addStandardVocabulary: MenuType new.
	self addStandardVocabulary: UnknownType new.
	self addStandardVocabulary: ScriptNameType new.
	self addStandardVocabulary: PointType new.

	#('simple' 'raised' 'inset' 'complex framed' 'complex raised' 'complex inset' 'complex alt framed' 'complex alt raised' 'complex alt inset') translatedNoopWithContext: ('EtoysVoca').
	self addStandardVocabulary: (SymbolListType new symbols: #(simple raised inset complexFramed complexRaised complexInset complexAltFramed complexAltRaised complexAltInset); vocabularyName: #BorderStyle; yourself).
	#('lines' 'arrows' 'arrowheads' 'dots') translatedNoopWithContext: 'EtoysVoca'.
	self addStandardVocabulary: (SymbolListType new symbols: #(lines arrows arrowheads dots); vocabularyName: #TrailStyle; yourself).
	#('left to right' 'right to left' 'top to bottom' 'bottom to top') translatedNoopWithContext: 'EtoysVoca'.
	self addStandardVocabulary: (SymbolListType new symbols: #(leftToRight rightToLeft topToBottom bottomToTop); vocabularyName: #ListDirection; yourself).

	#('top left' 'bottom right' 'center' 'justified') translatedNoopWithContext: 'EtoysVoca'.
	self addStandardVocabulary: (SymbolListType new symbols: #(topLeft bottomRight center justified); vocabularyName: #ListCentering; yourself).

	#('center' 'top left' 'top right' 'bottom left' 'bottom right' 'top center' 'left center' 'right center' 'bottom center') translatedNoopWithContext: 'EtoysVoca'.
	self addStandardVocabulary: (SymbolListType new symbols: #(center topLeft topRight bottomLeft bottomRight topCenter leftCenter rightCenter bottomCenter
);  vocabularyName: #CellPositioning; yourself).

	#('none' 'local rect' 'local square' 'global rect' 'global square') translatedNoopWithContext: 'EtoysVoca'.
	self addStandardVocabulary: (SymbolListType new symbols: #(none localRect localSquare globalRect globalSquare); vocabularyName: #CellSpacing; yourself).

	#('button down' 'while pressed' 'button up') translatedNoopWithContext: 'EtoysVoca'.
	self addStandardVocabulary: (SymbolListType new symbols: #(buttonDown whilePressed buttonUp); vocabularyName: #ButtonPhase; yourself).

	#('rotate' 'do not rotate' 'flip left right' 'flip up down') translatedNoopWithContext: 'EtoysVoca'.
	self addStandardVocabulary: (SymbolListType new symbols: #(rotate #'do not rotate' #'flip left right' #'flip up down'); vocabularyName: #RotationStyle; yourself).

	#('rigid' 'space fill' 'shrink wrap') translatedNoopWithContext: 'EtoysVoca'.
	self addStandardVocabulary: (SymbolListType new symbols: #(rigid spaceFill shrinkWrap); vocabularyName: #Resizing; yourself).

	self addStandardVocabulary: self newSystemVocabulary.  "A custom vocabulary for Smalltalk -- still under development)"

	self numberVocabulary.  		"creates and adds it"
	self wonderlandVocabulary.  	"creates and adds it"
	self vocabularyForClass: Time.   "creates and adds it"

	self addStandardVocabulary: (KedamaPatchType new vocabularyName: #Patch; yourself).
	#('wrap' 'stick' 'bouncing') translatedNoopWithContext: 'EtoysVoca'.
	self addStandardVocabulary: (SymbolListType new symbols: #(wrap stick bouncing); vocabularyName: #EdgeMode; yourself).
	#('log scale' 'linear' 'color') translatedNoopWithContext: 'EtoysVoca'.
	self addStandardVocabulary: (SymbolListType new symbols: #(logScale linear color); vocabularyName: #PatchDisplayMode; yourself).

	"Vocabulary initialize"! !


!EToyVocabulary class methodsFor: '*flexiblevocabularies-scripting' stamp: 'KR 7/30/2009 00:36'!
masterOrderingOfCategorySymbols
	"Answer a dictatorially-imposed presentation list of category symbols.
	This governs the order in which available vocabulary categories are presented in etoy viewers using the etoy vocabulary.
	The default implementation is that any items that are in this list will occur first, in the order specified here; after that, all other items will come, in alphabetic order by their translated wording."

	EToyVocabulary class decompile:  #masterOrderingOfCategorySymbols.
	self flag: #(('scripts' translatedNoop) ('variables' translatedNoop) ('as object' translatedNoop)).

	#('basic'  'color'  'geometry'  'more geometry' 
		'pen use'  'tests'  'motion'  'fill & border'  'scripting'  'sound'  
		'observation'  'button'  'layout'  'drag & drop'  'search'  'miscellaneous' )
			 translatedNoopWithContext: 'EtoysVoca'.

	^ #(basic  color  geometry  #'more geometry' #'pen use'  tests  motion  #'fill & border'  scripting sound  observation  button  layout  #'drag & drop'  search  miscellaneous)
! !

!EToyVocabulary class methodsFor: 'as yet unclassified' stamp: 'KR 7/29/2009 23:24'!
allPhrasesWithContextToTranslate
	| etoyVocab results literals additions |

	results := OrderedCollection new.
	etoyVocab := Vocabulary eToyVocabulary.
	etoyVocab initialize.		"just to make sure that it's unfiltered."
	self morphClassesDeclaringViewerAdditions do: [:cl |
		(cl class includesSelector: #additionsToViewerCategories)
			ifTrue: [
				literals := OrderedCollection new.
				cl additionsToViewerCategories do: [:group | 
					literals add: (Array 
								with: (group first)
								with: 'EtoysVoca').
					group second do: [:tuple |
						literals add: (Array
									with: (ScriptingSystem wordingForOperator: (tuple at: 2))
									with: 'EtoysVoca').  "wording"
						literals add: (Array
									with: (tuple at: 3)
									with: 'EtoysHelpString').  "help string"]].
				literals ifNotEmpty: [
					results add: {cl category. cl. #additionsToViewerCategories. literals}]].

		cl class selectors do: [:aSelector | ((aSelector beginsWith: 'additionsToViewerCategory')
								and: [(aSelector at: 26 ifAbsent: []) ~= $:])
			ifTrue: [
				literals := OrderedCollection new.
				additions := (cl perform: aSelector).
				literals add: (Array
							with: (additions first)
							with: 'EtoysVoca').
				additions second do: [:tuple |
					literals add: (Array
								with: (ScriptingSystem wordingForOperator: (tuple at: 2))
								with: 'EtoysVoca').  "wording"
					literals add: (Array
								with: (tuple at: 3)
								with: 'EtoysHelpString').  "help string"].
				literals ifNotEmpty: [
					results add: {cl category. cl. aSelector. literals}]]]].
	^results.! !

