'From etoys4.0 of 9 October 2008 [latest update: #2237] on 4 August 2009 at 12:52:09 am'!

!Object methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:31'!
descriptionForPartsBin
	"If the receiver is a member of a class that would like to be represented in a parts bin, answer the name by which it should be known, and a documentation string to be provided, for example, as balloon help.  When the 'nativitySelector' is sent to the 'globalReceiver', it is expected that some kind of Morph will result.  The parameters used in the implementation below are for documentation purposes only!!"

	^ DescriptionForPartsBin
		formalName: 'PutFormalNameHere' 
		categoryList: {'PutACategoryHere' . 'MaybePutAnotherCategoryHere' }
		documentation: 'Put the balloon help here' 
		globalReceiverSymbol: #PutAGlobalHere
		nativitySelector: #PutASelectorHere! !


!Flaps class methodsFor: 'flaps registry' stamp: 'KR 7/31/2009 12:55'!
defaultsQuadsDefiningScriptingFlap
	"Answer a structure defining the default items in the Scripting flap.
	previously in quadsDeiningScriptingFlap"

	^ ({
	{#TrashCanMorph.		#new.							'Trash' . 	'A tool for discarding objects' }.	
	{#ScriptingSystem.		#scriptControlButtons.			'Status' .	'Buttons to run, stop, or single-step scripts' }.
	{#AllScriptsTool.			#allScriptsToolForActiveWorld.	'All Scripts' .	'A tool that lets you control all the running scripts in your world' }.
	{#ScriptingSystem.		#newScriptingSpace.		'Scripting' . 	'A confined place for drawing and scripting, with its own private stop/step/go buttons.' }.

	{#PaintInvokingMorph.	#new.		'Paint' .	'Drop this into an area to start making a fresh painting there' }.
	{#ScriptableButton.		#authoringPrototype.	'Button' .		'A Scriptable button' }.
	{#ScriptingSystem.		#prototypicalHolder.		'Holder' .		'A place for storing alternative pictures in an animation, etc.' }.
	{#FunctionTile.			#randomNumberTile.	'Random' .	'A tile that will produce a random number in a given range' }.
	{#ScriptingSystem.		#anyButtonPressedTiles.	'ButtonDown?' .	'Tiles for querying whether the mouse button is down' }.
	{#ScriptingSystem.		#noButtonPressedTiles.	'ButtonUp?' .		'Tiles for querying whether the mouse button is up' }.

	{#SimpleSliderMorph.	#authoringPrototype.	'Slider' .		'A slider for showing and setting numeric values.' }.
	{#JoystickMorph	.		#authoringPrototype.	'Joystick' .	'A joystick-like control' }.
	{#TextFieldMorph.		#exampleBackgroundField.	'Scrolling Field'	. 'A scrolling data field which will have a different value on every card of the background' }.

	{#PasteUpMorph.	#authoringPrototype.		'Playfield' .	'A place for assembling parts or for staging animations' }.


	{#StackMorph. 		#authoringPrototype.		'Stack' . 		'A multi-card data base'	}.
	{#TextMorph.		#exampleBackgroundLabel.	'Background Label' . 'A piece of text that will occur on every card of the background' }.
	{#TextMorph	.		#exampleBackgroundField.	'Background Field' . 'A  data field which will have a different value on every card of the background' }
} translatedNoopWithContext: 'FlapDesc')  asOrderedCollection! !

!Flaps class methodsFor: 'flaps registry' stamp: 'KR 7/31/2009 12:56'!
defaultsQuadsDefiningStackToolsFlap
	"Answer a structure defining the items on the default system Stack Tools flap.
	previously in quadsDefiningStackToolsFlap"

	^ ({
	{#StackMorph. 		#authoringPrototype.	'Stack' . 			'A multi-card data base'	}.
	{#StackMorph.		#stackHelpWindow.	'Stack Help'	.	'Some hints about how to use Stacks' }.
	{#TextMorph	.		#authoringPrototype.	'Simple Text' .	'Text that you can edit into anything you wish' }.
	{#TextMorph	.		#fancyPrototype.		'Fancy Text' . 		'A text field with a rounded shadowed border, with a fancy font.' }.
	{#ScrollableField.	#newStandAlone.		'Scrolling Text' .		'Holds any amount of text; has a scroll bar' }.
	{#ScriptableButton.	#authoringPrototype.	'Scriptable Button' .	'A button whose script will be a method of the background Player' }.
	{#StackMorph.		#previousCardButton. 	'Previous Card' . 	'A button that takes the user to the previous card in the stack' }.
	{#StackMorph.		#nextCardButton.		'Next Card' .		'A button that takes the user to the next card in the stack' } } 
		translatedNoopWithContext: 'FlapDesc')  asOrderedCollection
! !

!Flaps class methodsFor: 'flaps registry' stamp: 'KR 7/31/2009 12:57'!
defaultsQuadsDefiningSuppliesFlap
	"Answer a list of quads which define the objects to appear in the default Supplies flap.
	previously in quadsDefiningSuppliesFlap"

	^ ({
	{#RectangleMorph. 	#authoringPrototype.		'Rectangle' 	.	'A rectangle' }.
	{#RectangleMorph.	#roundRectPrototype.		'RoundRect' .		'A rectangle with rounded corners' }.
	{#EllipseMorph.		#authoringPrototype.		'Ellipse' .			'An ellipse or circle' }.
	{#StarMorph.		#authoringPrototype.		'Star' .			'A star' }.
	{#PolygonMorph.		#curvePrototype.		'Curve' .			'A curve' }.
	{#PolygonMorph.	#authoringPrototype.		'Polygon' .		'A straight-sided figure with any number of sides' }.
	{#TextMorph	.		#authoringPrototype.	'Text' .			'Text that you can edit into anything you desire.' }.
	{#ScriptingSystem.	#prototypicalHolder. 		'Holder' .			'A place for storing alternative pictures in an animation, etc.' }.
	{#ImageMorph.		#authoringPrototype.		'Picture' .		'A non-editable picture of something' }.
	{#ScriptableButton.	#authoringPrototype.		'Button' .			'A Scriptable button' }.
	{#SimpleSliderMorph.	#authoringPrototype.	'Slider' .			'A slider for showing and setting numeric values.' }.
	{#PasteUpMorph.	#authoringPrototype.		'Playfield' .		'A place for assembling parts or for staging animations' }.
	{#BookMorph.		#authoringPrototype.		'Book' .			'A multi-paged structure' }.
	{#TabbedPalette.		#authoringPrototype.		'TabbedPalette' .	'A structure with tabs' }.
	{#JoystickMorph	.	#authoringPrototype.		'Joystick' .		'A joystick-like control' }.
	{#ClockMorph.		#authoringPrototype.		'Clock' .			'A simple digital clock' }.
	{#BookMorph.		#previousPageButton. 		'PreviousPage' .	'A button that takes you to the previous page' }.
	{#BookMorph.		#nextPageButton.			'NextPage' .		'A button that takes you to the next page' }
} translatedNoopWithContext: 'FlapDesc') asOrderedCollection! !

!Flaps class methodsFor: 'flaps registry' stamp: 'KR 7/31/2009 13:00'!
defaultsQuadsDefiningToolsFlap
	"Answer a structure defining the default Tools flap.
	previously in quadsDefiningToolsFlap"

	^ OrderedCollection new
	addAll: ({
	{#Browser. 		#prototypicalToolWindow.	'Browser'  .	'A Browser is a tool that allows you to view all the code of all the classes in the system' }.
	{#TranscriptStream.		#openMorphicTranscript.		'Transcript'  .		'A Transcript is a window usable for logging and debugging; browse references to #Transcript for examples of how to write to it.' }.
	{#Workspace.	#prototypicalToolWindow	.	'Workspace'  .		'A Workspace is a simple window for editing text.  You can later save the contents to a file if you desire.' }}
		translatedNoopWithContext: 'FlapDesc') ;
		add: ({ Preferences useFileList2 ifTrue: [ #FileList2 ] ifFalse: [ #FileList ].
				#prototypicalToolWindow.
				'File List' .
				'A File List is a tool for browsing folders and files on disks and FTP servers.'  } translatedNoopWithContext: 'FlapDesc');
	addAll: ({
	{#DualChangeSorter.		#prototypicalToolWindow.	'Change Sorter' .	'Shows two change sets side by side' }.
	{#SelectorBrowser,		#prototypicalToolWindow.	'Method Finder' .	'A tool for discovering methods by providing sample values for arguments and results' }.
	{#MessageNames	.	#prototypicalToolWindow	.	'Message Names' .		'A tool for finding, viewing, and editing all methods whose names contain a given character sequence.' }.
	{#Preferences.		#preferencesControlPanel.	'Preferences' .		'Allows you to control numerous options' }.
	{#Utilities.			#recentSubmissionsWindow.	'Recent' .				'A message browser that tracks the most recently-submitted methods' }.
	{#ProcessBrowser.	#prototypicalToolWindow.	'Processes' .		'A Process Browser shows you all the running processes' }.
	{#Preferences.		#annotationEditingWindow.	'Annotations' .	'Allows you to specify the annotations to be shown in the annotation panes of browsers, etc.' }.
	{#Scamper.			#newOpenableMorph.	'Scamper' .			'A web browser' }.
	{#Celeste.			#newOpenableMorph.	'Celeste' .				'Celeste -- an EMail reader' }.
	{#PackagePaneBrowser.	#prototypicalToolWindow	.	'Packages' .	'Package Browser:  like a System Browser, except that if has extra level of categorization in the top-left pane, such that class-categories are further organized into groups called "packages"' }.
	{#ChangeSorter.		#prototypicalToolWindow.	'Change Set' .		'A tool that allows you to view and manipulate all the code changes in a single change set' }
	} translatedNoopWithContext: 'FlapDesc');
		yourself! !

!Flaps class methodsFor: 'predefined flaps' stamp: 'KR 7/31/2009 12:53'!
defaultsQuadsDefiningPlugInSuppliesFlap
	"Answer a list of quads which define the objects to appear in the default Supplies flap used in the Plug-in image"
	^  ({
	{#ObjectsTool. #newStandAlone. 'Object Catalog' . 'A tool that lets you browse the catalog of available objects' }.
	{#AllScriptsTool. #allScriptsToolForActiveWorld. 'All Scripts' . 'Stop, Step, and Go buttons for controlling all your scripts at once.  The tool can also be "opened up" to control each script in your project individually.' }.
	{#AllPlayersTool. #allPlayersToolForActiveWorld. 'Players' . 'A tool listing all the scripted objects in the project.' }.
	{#TrashCanMorph. #new	. 'Trash' . 'A tool for discarding objects' }.
	{#TextMorph	. #authoringPrototype. 'Text' .	'Text that you can edit into anything you desire.' }.
	{#RecordingControls. #authoringPrototype. 'Sound Recorder' . 'A device for making sound recordings.' }.
	{#RectangleMorph. #authoringPrototype. 'Rectangle' . 'A rectangle' }.
	{#EllipseMorph. #authoringPrototype. 'Ellipse' .  'An ellipse or circle' }.
	{#StarMorph. #authoringPrototype. 'Star' . 'A star' }.
	{#BookMorph. #authoringPrototype. 'Book' . 'A multi-paged structure' }.
	{#ScriptingSystem. #prototypicalHolder. 'Holder' . 'A place for storing alternative pictures in an animation, etc.' }.
	{#JoystickMorph	. #authoringPrototype. 'Joystick' . 'A joystick-like control' }.
	{#PasteUpMorph. #authoringPrototype. 'Playfield' . 'A place for assembling parts or for staging animations' }.
	{#ScriptableButton. #authoringPrototype. 'Button' . 'A button to use with tile scripting; its script will be a method of its containing playfield' }.
	{#SimpleSliderMorph.	#authoringPrototype.	'Slider' .	'A slider for showing and setting numeric values.' }.

} translatedNoopWithContext: 'FlapDesc') asOrderedCollection! !

!Flaps class methodsFor: '*green' stamp: 'KR 7/31/2009 13:02'!
defaultsQuadsDefiningWidgetsFlap
	"Answer a structure defining the default Widgets flap.
     previously in quadsDefiningWidgetsFlap"

	^ ({
	{#TrashCanMorph. #new	. 'Trash' . 'A tool for discarding objects' }.
	{#AllScriptsTool. #allScriptsToolForActiveWorld. 'All Scripts' . 'A tool that lets you see and control all the running scripts in your project' }.
	{#ObjectsTool. #newStandAlone. 'Object Catalog' . 'A tool that lets you browse the catalog of objects' }.
	{#PaintInvokingMorph. #new. 'Paint' . 'Drop this into an area to start making a fresh painting there' }.
	{#GeeMailMorph	. #new. 'Gee-Mail' . 'A place to present annotated content' }.
	{#RecordingControls. #authoringPrototype. 'Sound' . 'A device for making sound recordings.' }.
	{#MPEGMoviePlayerMorph. #authoringPrototype. 'Movie Player' . 'A Player for MPEG movies' }.
	{#FrameRateMorph. #authoringPrototype	. 'Frame Rate' . 'An indicator of how fast your system is running' }.
	{#MagnifierMorph. #newRound. 'Magnifier' . 'A magnifying glass' }.
	{#ScriptingSystem. #newScriptingSpace. 'Scripting' . 'A confined place for drawing and scripting. with its own private stop/step/go buttons.' }.
	{#ScriptingSystem. #holderWithAlphabet. 'Alphabet' . 'A source for single-letter objects' }.
	{#BouncingAtomsMorph. #new. 'Bouncing Atoms' .	'Atoms, mate' }.
	{#ClockMorph. #authoringPrototype. 'Clock' . 'A simple digital clock' }

	} translatedNoopWithContext: 'FlapDesc') asOrderedCollection! !


!GetTextExporter2 methodsFor: 'exporting' stamp: 'KR 7/31/2009 02:17'!
appendTranslations: domains 
	self appendStringReceivers: #translated into: domains.
	self appendStringReceivers: #translatedNoop into: domains.
	self appendStringReceiversAndContext: #translatedWithContext: into: domains.
	self appendStringReceiversAndContext: #translatedNoopWithContext: into: domains.
	self appendVocabularies: domains.
	self appendPartDesciptions: domains.
! !

!GetTextExporter2 methodsFor: 'private' stamp: 'KR 7/31/2009 02:35'!
appendPartDesciptions: domains
	| literalsForDomain literal contexts msgctxt references domainName |
	
	self listPartDescriptions do: [ :tuple |
		domainName _ self getTextDomainForClassCategory: tuple first category.
		literalsForDomain _ domains at: domainName ifAbsentPut: [Dictionary new].
		literal _ tuple third.
		msgctxt _ tuple fourth.
		contexts _ literalsForDomain at: literal ifAbsentPut: [Dictionary new].
		references _ contexts  at: msgctxt ifAbsentPut: [OrderedCollection new].
		references add: (MethodReference new 
										setStandardClass: (tuple first)
										methodSymbol: (tuple second)).
	]. ! !

!GetTextExporter2 methodsFor: 'private' stamp: 'KR 7/31/2009 12:42'!
listPartDescriptions
	| literals classes desc|
	literals _ OrderedCollection new. 
	classes _ Morph withAllSubclasses.
	classes do: [:aClass |
		(aClass class includesSelector: #descriptionForPartsBin) ifTrue: [
			desc _ aClass descriptionForPartsBin.
			literals add: (Array 
						with: aClass
						with: #descriptionForPartsBin
						with: (desc formalName)
						with: 'PartDesc').
			desc categories do: [:category |
				literals add: (Array
						with: aClass
						with: #descriptionForPartsBin
						with: category
						with: 'PartDesc').
			].
			literals add: (Array
						with: aClass
						with: #descriptionForPartsBin
						with: (desc documentation)
						with: 'PartDesc').
		].
		(aClass class includesSelector: #formerDescriptionForPartsBin) ifTrue: [
			desc _ aClass formerDescriptionForPartsBin.
			literals add: (Array 
						with: aClass
						with: #formerDescriptionForPartsBin
						with: (desc formalName)
						with: 'PartDesc').
			desc categories do: [:category |
				literals add: (Array
						with: aClass
						with: #formerDescriptionForPartsBin
						with: category
						with: 'PartDesc').
			].
			literals add: (Array
						with: aClass
						with: #formerDescriptionForPartsBin
						with: (desc documentation)
						with: 'PartDesc').
		].
		(aClass class includesSelector: #supplementaryPartsDescriptions) ifTrue: [
			aClass supplementaryPartsDescriptions do: [:suplDesc|
				literals add: (Array 
						with: aClass
						with: #supplementaryPartsDescriptions
						with: (suplDesc formalName)
						with: 'PartDesc').
				suplDesc categories do: [:category |
					literals add: (Array
						with: aClass
						with: #supplementaryPartsDescriptions
						with: category
						with: 'PartDesc').
				].
				literals add: (Array
						with: aClass
						with: #supplementaryPartsDescriptions
						with: (suplDesc documentation)
						with: 'PartDesc').
			].
		].
	].
	^literals! !


!Morph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:54'!
supplementaryPartsDescriptions
	"Answer a list of DescriptionForPartsBin objects that characterize objects that this class wishes to contribute to Stationery bins *other* than by the standard default #newStandAlone protocol"

	^ {	DescriptionForPartsBin
			formalName: 'Status' 
			categoryList: #()
			documentation: 'Buttons to run, stop, or single-step scripts' 
			globalReceiverSymbol: #ScriptingSystem
			nativitySelector: #scriptControlButtons.
		DescriptionForPartsBin
			formalName: 'Scripting' 
			categoryList: {'Scripting' }
			documentation: 'A confined place for drawing and scripting, with its own private stop/step/go buttons.' 
			globalReceiverSymbol: #ScriptingSystem
			nativitySelector: #newScriptingSpace.
		DescriptionForPartsBin
			formalName: 'Random' 
			categoryList: {'Scripting' }
			documentation: 'A tile that will produce a random number in a given range' 
			globalReceiverSymbol: #FunctionTile
			nativitySelector: #randomNumberTile.
		DescriptionForPartsBin
			formalName: 'ButtonDown?' 
			categoryList: {'Scripting' }
			documentation: 'Tiles for querying whether the mouse button is down' 
			globalReceiverSymbol: #ScriptingSystem
			nativitySelector: #anyButtonPressedTiles.
		DescriptionForPartsBin
			formalName: 'ButtonUp?' 
			categoryList: {'Scripting' }
			documentation: 'Tiles for querying whether the mouse button is up' 
			globalReceiverSymbol: #ScriptingSystem
			nativitySelector: #noButtonPressedTiles.
		DescriptionForPartsBin
			formalName: 'NextPage' 
			categoryList: {'Multimedia' }
			documentation: 'A button which, when clicked, takes the reader to the next page of a book' 
			globalReceiverSymbol: #BookMorph
			nativitySelector: #nextPageButton.
		DescriptionForPartsBin
			formalName: 'PreviousPage' 
			categoryList: {'Multimedia'}
			documentation: 'A button which, when clicked, takes the reader to the previous page of a book' 
			globalReceiverSymbol: #BookMorph
			nativitySelector: #previousPageButton.},

	self partsDescriptionsFromToolsFlap! !


!ArchiveViewer class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:24'!
descriptionForPartsBin

	^ self partName: 'Zip Tool' 
		categories: #()
		documentation: 'A viewer and editor for Zip archive files' 
! !


!BouncingAtomsMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:24'!
descriptionForPartsBin
	^ self partName:	'BouncingAtoms' 
		categories:		{'Just for Fun' }
		documentation:	'The original, intensively-optimized bouncing-atoms simulation by John Maloney' ! !


!BroomMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:25'!
descriptionForPartsBin
	^ self partName: 	'Broom' 
		categories:		{'Graphics' }
		documentation:	'A broom to align Morphs with' ! !


!ChessMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:25'!
descriptionForPartsBin
	^ self partName: 	'Chess' 
		categories:		{'Games' }
		documentation:	'A fine game of chess' ! !


!ChineseCheckers class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:25'!
descriptionForPartsBin
	^ self partName:	'ChineseCheckers' 
		categories:		{'Games' }
		documentation:	'Halma - the classic board game of Chinese Checkers, written by Dan Ingalls' ! !


!CipherPanel class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:25'!
descriptionForPartsBin
	^ self partName:	'Cipher' 
		categories:		{'Games' }
		documentation:	'The Cipher Panel: A playground for cryptograms, by Dan Ingalls' ! !


!ClockMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:25'!
descriptionForPartsBin
	"Answer a description for use in parts bins."

	^ self partName:	'Digital Clock' 
		categories:		{'Just for Fun' }
		documentation:	'A digital clock' ! !


!CrosticPanel class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:26'!
descriptionForPartsBin
	^ self partName:	'Crostic' 
		categories:		{'Games' }
		documentation:	'The Crostic Panel: A classic word diagram game, by Dan Ingalls' ! !


!EllipseMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:26'!
descriptionForPartsBin
	^ self partName:	'Ellipse' 
		categories:		{'Graphics' translatedNoop. 'Basic' }
		documentation:	'An elliptical or circular shape' ! !


!CircleMorph class methodsFor: 'as yet unclassified' stamp: 'KR 7/31/2009 01:51'!
supplementaryPartsDescriptions
	"Extra items for parts bins"

	^ {DescriptionForPartsBin
		formalName: 'Circle' 
		categoryList: {'Graphics' }
		documentation: 'A circular shape' 
		globalReceiverSymbol: #CircleMorph 
		nativitySelector: #newStandAlone.

	DescriptionForPartsBin
		formalName: 'Pin' 
		categoryList: {'Connectors' }
		documentation: 'An attachment point for Connectors that you can embed in another Morph.' 
		globalReceiverSymbol: #NCPinMorph 
		nativitySelector: #newPin.
}! !


!Flasher class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:28'!
descriptionForPartsBin
	"Answer a description of the receiver for use in a parts bin"

	^ self partName:	'Flasher' 
		categories:		{'Just for Fun' }
		documentation:	'A circle that flashes' ! !


!FrameRateMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:28'!
descriptionForPartsBin
	^ self partName:	'FrameRate' 
		categories:		{'Just for Fun' }
		documentation:	'A readout that allows you to monitor the frame rate of your system' ! !


!ImageMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:29'!
descriptionForPartsBin
	^ self partName:	'Image' 
		categories:		#()
		documentation:	'A non-editable picture.  If you use the Paint palette to make a picture, you can edit it afterwards.' ! !


!GrabPatchMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:28'!
descriptionForPartsBin
	"Answer a description of the receiver's instances for a parts bin"

	^ self partName:	'Grab Patch' 
		categories:		{'Graphics' }
		documentation:	'Use this to grab a rectangular patch from the screen' ! !


!JoystickMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:29'!
descriptionForPartsBin
	^ self partName: 	'Joystick' 
		categories:		{'Basic' }
		documentation:	'A joystick-like control' ! !


!KedamaMorph class methodsFor: 'class initialization' stamp: 'KR 7/31/2009 01:52'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Particles' 
		categoryList: {'Basic' }
		documentation: 'A Kedama World with pre-made components' 
		globalReceiverSymbol: #KedamaMorph
		nativitySelector: #newSet.
	}! !


!LassoPatchMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:29'!
descriptionForPartsBin
	"Answer a description of the receiver to be used in a parts bin"

	^ self partName:	'Lasso' 
		categories:		{'Graphics' }
		documentation:	'Drop this icon to grab a patch from the screen with a lasso.' ! !


!MagnifierMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:30'!
descriptionForPartsBin
	^ self partName:	'Magnifier' 
		categories:		{'Just for Fun' }
		documentation:	'A magnifying glass' ! !

!MagnifierMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:52'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'RoundGlass' 
		categoryList: {'Just for Fun' }
		documentation: 'A round magnifying glass' 
		globalReceiverSymbol: #MagnifierMorph
		nativitySelector: #newRound.
		
	DescriptionForPartsBin
		formalName: 'Hand Magnifier' 
		categoryList: #()
		documentation: 'A magnifying glass that also shows Morphs in the Hand and displays the Hand position.' 
		globalReceiverSymbol: #MagnifierMorph
		nativitySelector: #newShowingPointer }! !


!FishEyeMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:28'!
descriptionForPartsBin
	^ self partName:	'FishEye' 
		categories:		#()
		documentation:	'An extreme-wide-angle lens' ! !


!MovingEyeMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:30'!
descriptionForPartsBin
	^ self partName:	'MovingEye' 
		categories:		{'Just for Fun' }
		documentation:	'An eye which follows the cursor' ! !


!NCAAConnectorMorph class methodsFor: 'new-morph participation' stamp: 'KR 7/31/2009 01:56'!
supplementaryPartsDescriptions
	| descriptions |
	"PartsBin clearThumbnailCache; cacheAllThumbnails"
	descriptions _ OrderedCollection new.
	descriptions addAll: {
	DescriptionForPartsBin
		formalName: 'Connector' 
		categoryList: {'Connectors' }
		documentation: 'A basic Connector' 
		globalReceiverSymbol: #NCAAConnectorMorph
		nativitySelector: #newStandAlone.

	DescriptionForPartsBin
		formalName: 'ConnectorArrow' 
		categoryList: {'Connectors' }
		documentation: 'A basic Connector with an arrowhead' 
		globalReceiverSymbol: #NCAAConnectorMorph
		nativitySelector: #newWithArrow.
		
	DescriptionForPartsBin
		formalName: 'Curvy Connector' 
		categoryList: {'Connectors' }
		documentation: 'A basic Connector that bends smoothly' 
		globalReceiverSymbol: #NCAAConnectorMorph
		nativitySelector: #newCurvyConnector.

	DescriptionForPartsBin
		formalName: 'Curvy ConnectorArrow' 
		categoryList: {'Connectors' }
		documentation: 'A basic smooth Connector with an arrowhead' 
		globalReceiverSymbol: #NCAAConnectorMorph
		nativitySelector: #newCurvyArrow.
	}.

	(Flaps respondsTo: #newNCPartsBinFlap) ifTrue: [
		descriptions add: (
	(DescriptionForPartsBin
		formalName: 'Button Flap' 
		categoryList: {'Connectors' }
		documentation: 'A blank buttton flap' 
		globalReceiverSymbol: #Flaps
		nativitySelector: #newNCPartsBinFlap)
			sampleImageForm: self buttonFlapImage; yourself) ].

	(Flaps respondsTo: #newConnectorsFlap) ifTrue: [
		descriptions add: (
	(DescriptionForPartsBin
		formalName: 'Connectors Flap' 
		categoryList: {'Connectors' }
		documentation: 'A pre-loaded Connectors flap' 
		globalReceiverSymbol: #Flaps
		nativitySelector: #newConnectorsFlap)
			sampleImageForm: self connectorsFlapImage; yourself) ].

	Smalltalk at: #NCMakerButton ifPresent: [ :ncmb |
		descriptions addAll: {
	DescriptionForPartsBin
		formalName: 'Connector Button' 
		categoryList: {'Connectors' }
		documentation: 'A Maker Button with a Connector loaded' 
		globalReceiverSymbol: #NCAAConnectorMorph
		nativitySelector: #newMakerButton.
	DescriptionForPartsBin
		formalName: 'Random Connectors' 
		categoryList: {'Connectors' }
		documentation: 'A button that makes fancy Connectors at random' 
		globalReceiverSymbol: #NCAAConnectorMorph
		nativitySelector: #newRandomButton.
		}
	].
	^descriptions
! !


!NCBroomMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:31'!
descriptionForPartsBin
	^ self partName: 	'Connector Broom' 
		categories:		{'Connectors' }
		documentation:	'A broom to align shapes with' ! !


!NCCompositeStateMorph class methodsFor: 'instance creation' stamp: 'KR 7/31/2009 01:56'!
supplementaryPartsDescriptions
	"Extra items for parts bins"
	Preferences eToyFriendly ifTrue: [ ^#() ].

	^ {DescriptionForPartsBin
		formalName: 'Composite State' 
		categoryList: #()
		documentation: 'A UML composite state shape' 
		globalReceiverSymbol: #NCCompositeStateMorph
		nativitySelector: #newCompositeState.
DescriptionForPartsBin
		formalName: 'UML Package' 
		categoryList: #()
		documentation: 'A UML package shape' 
		globalReceiverSymbol: #NCCompositeStateMorph
		nativitySelector: #newUMLPackage.
}! !


!NCGlyphEditor class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:31'!
descriptionForPartsBin
	^ self partName:	'Arrow Editor' 
		categories:		{'Connectors' }
		documentation:	'A tool that lets you edit Connectors arrow shapes.' 
! !


!NCLabelMorph class methodsFor: 'instance creation' stamp: 'KR 7/31/2009 01:58'!
supplementaryPartsDescriptions

	Preferences eToyFriendly ifTrue: [ ^#() ].

	^ {
			DescriptionForPartsBin
					formalName: 'Label' 
					categoryList: {'Connectors' }
					documentation: 'A label that can be attached to another morph by dropping or menu choice and will follow the morph to which it is attached.' 
					globalReceiverSymbol: #NCLabelMorph 
					nativitySelector: #newStandAlone.	
	}! !


!NCSchematicConnectorMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:31'!
descriptionForPartsBin
	^ self partName:	'Schematic Connector' 
		categories:		{'Connectors' }
		documentation:	'A Connector whose endpoints automatically become dots when connected.' 
! !


!NCScrolledCompositeStateMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:58'!
supplementaryPartsDescriptions
	"Extra items for parts bins"
	^Preferences eToyFriendly ifTrue: [ #() ]
		ifFalse: [ {
	DescriptionForPartsBin
		formalName: 'Scrolled State' 
		categoryList: #()
		documentation: 'A UML State shape with scrollbars' 
		globalReceiverSymbol: #NCScrolledCompositeStateMorph 
		nativitySelector: #authoringPrototype  } ]
! !


!NCSmartLabelMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:59'!
supplementaryPartsDescriptions

	Preferences eToyFriendly ifTrue: [ ^#() ].

	^ {
		DescriptionForPartsBin
				formalName: 'Smart Label' 
				categoryList: {'Connectors' }
				documentation: 'A label that can be attached to another morph by dropping or menu choice and will follow the morph to which it is attached, trying to stay out of the way.' 
				globalReceiverSymbol: #NCSmartLabelMorph 
				nativitySelector: #newStandAlone.
	}! !


!NCTextRectangleMorph class methodsFor: 'instance creation' stamp: 'KR 7/31/2009 01:59'!
supplementaryPartsDescriptions

	^ {
DescriptionForPartsBin
		formalName: 'Text Rectangle' 
		categoryList: {'Connectors' }
		documentation: 'A rectangle with text, or a button' 
		globalReceiverSymbol: #NCTextRectangleMorph 
		nativitySelector: #new.
}! !


!NCCurveMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:57'!
supplementaryPartsDescriptions
	Preferences eToyFriendly ifTrue: [ ^#() ].

	^ {
	DescriptionForPartsBin
		formalName: 'Diamond' 
		categoryList: #()
		documentation: 'A diamond shape with text inside' 
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #diamond.
	DescriptionForPartsBin
		formalName: 'Pointing Hand' 
		categoryList: #()
		documentation: 'A pointing hand shape with text inside' 
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #pointingHand.
	DescriptionForPartsBin
		formalName: 'CircleCurve' 
		categoryList: #()
		documentation: 'A circle shape with text inside' 
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #circle.
	DescriptionForPartsBin
		formalName: 'AND Gate' 
		categoryList: #()
		documentation: 'An ''and gate'' shape with text inside' 
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #andGate.
	DescriptionForPartsBin
		formalName: 'OR Gate' 
		categoryList: #()
		documentation: 'An ''or gate'' shape with text inside' 
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #orGate.
	DescriptionForPartsBin
		formalName: 'XOR Gate' 
		categoryList: #()
		documentation: 'An ''xor gate'' shape with text inside' 
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #xorGate.
	DescriptionForPartsBin
		formalName: 'Happy face' 
		categoryList: #()
		documentation: 'A happy face' 
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #happyFace.
	DescriptionForPartsBin
		formalName: 'Sad face' 
		categoryList: #()
		documentation: 'A sad face' 
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #sadFace.
	DescriptionForPartsBin
		formalName: 'Pointing Hand2' 
		categoryList: #()
		documentation: 'Another pointing hand' 
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #pointingHand2.
	}.! !


!NCEllipseMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:58'!
supplementaryPartsDescriptions
	"Extra items for parts bins"
	| descriptions |
	descriptions := OrderedCollection new.

	descriptions add: (
	DescriptionForPartsBin
		formalName: 'Text Ellipse' 
		categoryList: {'Connectors' }
		documentation: 'An elliptical or circular shape with text' 
		globalReceiverSymbol: #NCEllipseMorph 
		nativitySelector: #newStandAlone ).

	Preferences eToyFriendly ifTrue: [ ^descriptions ].

	descriptions addAll: {
	DescriptionForPartsBin
		formalName: 'End State' 
		categoryList: #()
		documentation: 'A UML end state shape' 
		globalReceiverSymbol: #NCEllipseMorph 
		nativitySelector: #newEndState.
	DescriptionForPartsBin
		formalName: 'Start State' 
		categoryList: #()
		documentation: 'A UML start state shape' 
		globalReceiverSymbol: #NCEllipseMorph 
		nativitySelector: #newStartState. }.

	^descriptions! !


!NCNoteMorph class methodsFor: 'instance creation' stamp: 'KR 7/31/2009 01:58'!
supplementaryPartsDescriptions
	"Extra items for parts bins"
	^Preferences eToyFriendly ifTrue: [ #() ]
		ifFalse: [ {
	DescriptionForPartsBin
		formalName: 'Note' 
		categoryList: #()
		documentation: 'A UML note shape' 
		globalReceiverSymbol: #NCNoteMorph 
		nativitySelector: #authoringPrototype  } ]

	! !


!NCUMLDiagramMorph class methodsFor: 'as yet unclassified' stamp: 'KR 7/31/2009 01:59'!
supplementaryPartsDescriptions
	Preferences eToyFriendly ifTrue: [ ^#() ].

	^ {
DescriptionForPartsBin
		formalName: 'State' 
		categoryList: #()
		documentation: 'A UML State shape' 
		globalReceiverSymbol: #NCUMLDiagramMorph
		nativitySelector: #newStateSymbol.

DescriptionForPartsBin
		formalName: 'Class' 
		categoryList: #()
		documentation: 'A UML class symbol' 
		globalReceiverSymbol: #NCUMLDiagramMorph 
		nativitySelector: #newUMLClassSymbol .

}! !


!NCSTUMLDiagramMorph class methodsFor: 'instance creation' stamp: 'KR 7/31/2009 01:59'!
supplementaryPartsDescriptions

	Preferences eToyFriendly ifTrue: [ ^#() ].

	^  { DescriptionForPartsBin
		formalName: 'STClass' 
		categoryList: #()
		documentation: 'A UML class symbol that can read its text from a Squeak class' 
		globalReceiverSymbol: #NCSTUMLDiagramMorph 
		nativitySelector: #newUMLClassSymbol }
! !


!ObjectsTool methodsFor: 'categories' stamp: 'KR 7/31/2009 02:39'!
tabsForCategories
	"Answer a list of buttons which, when hit, will trigger the choice of a category"

	| buttonList aButton classes categoryList basic |
	classes _ Morph withAllSubclasses.
	categoryList _ Set new.
	classes do: [:aClass |
		(aClass class includesSelector: #descriptionForPartsBin) ifTrue:
			[categoryList addAll: aClass descriptionForPartsBin categories].
		(aClass class includesSelector: #supplementaryPartsDescriptions) ifTrue:
			[aClass supplementaryPartsDescriptions do:
				[:aDescription | categoryList addAll: aDescription categories]]].

	categoryList _ OrderedCollection withAll: (categoryList asSortedArray).
	
	basic := categoryList remove: ' Basic'  ifAbsent: [ ].
	basic ifNotNil: [ categoryList addFirst: basic ].

	basic := categoryList remove: 'Basic'  ifAbsent: [ ].
	basic ifNotNil: [ categoryList addFirst: basic ].

	buttonList _ categoryList collect:
		[:catName |
			aButton _ SimpleButtonMorph new   label: (catName translatedWithContext: 'PartDesc') 
											font: Preferences standardEToysButtonFont.
			aButton actWhen: #buttonDown.
			aButton target: self; actionSelector: #showCategory:fromButton:; arguments: {catName. aButton}].
	^ buttonList

"ObjectsTool new tabsForCategories"! !


!PaintInvokingMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:32'!
descriptionForPartsBin
	^ self partName:	'Paint' 
		categories:		#()
		documentation:	'Drop this icon to start painting a new object.' ! !


!PasteUpMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:32'!
descriptionForPartsBin
	^ self partName:	'Playfield' 
		categories:		{'Basic' }
		documentation:	'A place for assembling parts or for staging animations' ! !

!PasteUpMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 02:00'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Holder' 
		categoryList: {'Scripting' }
		documentation: 'A place for storing alternative pictures in an animation, ec.' 
		globalReceiverSymbol: #ScriptingSystem
		nativitySelector: #prototypicalHolder}! !


!NCAttachmentPointAdjusterWindow class methodsFor: 'opening' stamp: 'KR 7/31/2009 01:30'!
descriptionForPartsBin
	^ self partName:	'Attachment Adjuster' 
		categories:		{'Connectors' }
		documentation:	'This lets you adjust the attachment points on a dropped Morph' ! !


!PartsBin class methodsFor: 'private' stamp: 'KR 7/31/2009 02:43'!
translatedQuads: quads
	"private - convert the given quads to a translated one"
	
	| translatedQuads |

	translatedQuads := quads collect: [:each |
		| element |
		element := each copy. 
		element at: 3 put: (each third translatedWithContext: 'PartDesc').
		element at: 4 put: (each fourth translatedWithContext: 'PartDesc').
		element.
	].

	^ translatedQuads
! !


!PDAMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:32'!
descriptionForPartsBin
	^ self partName:	'PDA' 
		categories:		#()
		documentation:	'A Personal Digital Assistant' ! !


!PolygonMorph class methodsFor: 'instance creation' stamp: 'KR 7/31/2009 02:01'!
supplementaryPartsDescriptions
	"Answer a list of DescriptionForPartsBin objects that characterize objects that this class wishes to contribute to Stationery bins *other* than by the standard default #newStandAlone protocol"

	^ {DescriptionForPartsBin
		formalName: 'Arrow' 
		categoryList: {'Graphics' }
		documentation: 'A line with an arrowhead.  Shift-click to get handles and move the ends.' 
		globalReceiverSymbol: #PolygonMorph
		nativitySelector: #arrowPrototype.
	DescriptionForPartsBin
		formalName: 'Triangle' 
		categoryList: {'Graphics' }
		documentation: 'A three-sided polygon.' 
		globalReceiverSymbol: #PolygonMorph
		nativitySelector: #trianglePrototype.

		DescriptionForPartsBin
		formalName: 'Curve' 
		categoryList: {'Graphics' .  'Basic' }
		documentation: 'A smooth wiggly curve, or a curved solid.  Shift-click to get handles and move the points.  Using the halo menu, can be coverted into a polygon, and can be made "open" rather than closed.' 
		globalReceiverSymbol: #PolygonMorph
		nativitySelector: #curvePrototype.
 }

	
! !

!PolygonMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:32'!
descriptionForPartsBin
	^ self partName:	'Polygon' 
		categories:		{'Graphics' translatedNoop. 'Basic' }
		documentation:	'A series of connected line segments, which may be a closed solid, or a zig-zag line.  Shift-click to get handles and move the points.' ! !


!CurveMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 12:37'!
formerDescriptionForPartsBin
	"Formerly, the definition that resulted in there being a Curve in the objects catalog, etc.  We now use a generic PolygonMorph, configured to be curve-like, instead..."

	^ self partName:	'Curve' 
		categories:		{'Graphics' . 'Basic' }
		documentation:	'A smooth wiggly curve, or a curved solid.  Shift-click to get handles and move the points.  Using the halo menu, can be coverted into a polygon, and can be made "open" rather than closed.' ! !

!CurveMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:52'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Curvy Arrow' 
		categoryList: {'Graphics' }
		documentation: 'A curved line with an arrowhead.  Shift-click to get handles and move the points.' 
		globalReceiverSymbol: #CurveMorph
		nativitySelector: #arrowPrototype}
! !


!LineMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:30'!
descriptionForPartsBin
	"Answer a description for the parts bin."

	^ self partName:	'Line' 
		categories:		{'Graphics' }
		documentation:	'A straight line.  Shift-click to get handles and move the ends.' ! !


!RectangleMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:33'!
descriptionForPartsBin
	^ self partName:	'Rectangle' 
		categories:		{'Graphics' translatedNoop. 'Basic' }
		documentation:	'A rectangular shape, with border and fill style' ! !

!RectangleMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 02:01'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'RoundRect' 
		categoryList: {'Graphics' translatedNoop. 'Basic' }
		documentation: 'A rectangle with rounded corners' 
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #roundRectPrototype.

	DescriptionForPartsBin
		formalName: 'Gradient' 
		categoryList: #()
		documentation: 'A rectangle with a horizontal gradient' 
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #gradientPrototype.

	DescriptionForPartsBin
		formalName: 'Gradient (slanted)' 
		categoryList: #()
		documentation: 'A rectangle with a diagonal gradient' 
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #diagonalPrototype}! !


!AlignmentMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:51'!
supplementaryPartsDescriptions
	"Extra items for parts bins"

	^ {DescriptionForPartsBin
		formalName: 'Column' 
		categoryList: #()
		documentation: 'An object that presents the things within it in a column' 
		globalReceiverSymbol: #AlignmentMorph
		nativitySelector: #columnPrototype.
	DescriptionForPartsBin
		formalName: 'Row' 
		categoryList: #()
		documentation: 'An object that presents the things within it in a row' 
		globalReceiverSymbol: #AlignmentMorph
		nativitySelector: #rowPrototype}! !


!AllPlayersTool class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:24'!
descriptionForPartsBin
	"Answer a description for use in parts bins"

	^ self partName: 	'Players' 
		categories:		{'Scripting' }
		documentation:	'A tool showing all the players in your project' ! !


!AllScriptsTool class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:24'!
descriptionForPartsBin
	"Answer a description for use in parts bins"

	^ self partName: 	'All Scripts' 
		categories:		{'Scripting' }
		documentation:	'A tool allowing you to monitor and change the status of all scripts in your project' ! !


!BookMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:24'!
descriptionForPartsBin
	^ self partName:	'Book' 
		categories:		{'Multimedia' }
		documentation:	'Multi-page structures' 
		sampleImageForm: (PNGReadWriter on: (Base64MimeConverter mimeDecodeToBytes: 'iVBORw0KGgoAAAANSUhEUgAAAMgAAACgCAYAAABJ/yOpAAAABHNCSVQFBQUBSsjp7wAABMtJ
REFUeF7l3S2S4kAAgFEkEonkCEiOgEQikUgkEolEcgSOgEQiOcYcAZfdniqmpnaBkE43JHni
7dZuzWR7m3z5ISHT6/X6hc/ne+TvL9fr1efz/cMPxOfzA/H5/EB8Pj8Qn88PxOfzA/H5OhLI
19eXz9dZfiA+nx+Iz+cH4vN1K5Dz+fxUEyaoCWP0xwAF8ntSy94l+NQL0IQx+mMAA3llop+9
AO+K49Nj9MeABfLqVujVrVTOvcYnx+iPAQwkxWTn3kI1YYz+GMBAckx4kw4lUo3RH4MfiB9I
hTHU/ZSbH0gLAsk54akmvuoYY+5LKxvjvTGkDCR2DKnnoq2RZAkkNo4cK2DKOGJv3Hw0xkdj
SB1IzBhyzEedSC6XS7Hf74vFYlGMx+Nit9uVfs9yufz++jrLaFwg75r0KmMsW/nkQKrMSexr
dTgc/vs/rlar0u/r9/vfkdRZRiMDecekvzrGV1Y+PZBX5yX2tTqdTsVmsymOx+PPir5er0uj
CoGE74ldRpZA6px7xK6Mud7OrLtSPhvjszHkCKTqGHLMQYpzkdvKXbb1D3uO0WhUaxmNDyTX
pKdeMXIFkvoQNXcgMfMQG0jZ1n84HP4cXsUuoxWB5Jj0sjGm3GprgZSN+x17kHA4Fb4mfG3n
9yA5Jj3H4Y1/iBU3hhx7kHCuMRgMau+F/ED8QFobyLOt/2QyKebzee3zGP8Qyz/Eau0h1qOt
f7jWEd69Ctc7iD2If5Lun6RX2fqHi3/PDq86tQfx3+b13+atuvUPh1az2SzJO2H+hUL/QmEr
LhTermuELX5Y+cO/F84zwp/D34d3rX5fPd9ut7WW4d9q0pJbTVLOX5tvNbmdeIf7p+79frta
ftszhPOQ2GX4Nyu26GbFNgTSpDt6w02I0+nUv93dv93dv9390Qn6o4uD/gem/A9M+R+Y8j9R
6H/k1v/Irf/QBv+hDf5DG/zH/viP/fHH4AfiPzjOH4MfiP/oUf/Ro/6jR/2HV/sPr/YfXu3/
+AOfzw/E5/MD8fn8QHy+pgfi8/k/BtqfDJ/PD8Tn8wPx+fxAfD4/EJ/PD8Tn8wPx+fxAfD4/
EJ/PD8Tn8/mB+Hx+ID6fH4jP5wfi8/mB+Hx+ID6fH4jP5wfi8/mB+Hx+ID6fzw/E5/MD8fn8
QHw+PxCfzw/E5/MD8fn8QHw+PxCfzw/E5/MD8QPx+fxAfD4/EJ/PD8Tn8wPx+fxAfL47ro3i
B+Lz+YH4fH4gPp8fiM/nB+Lz+YH4fH4gPp8fiM/nB+Lz+YH4fD4/EJ/PD8Tn8wPx+fxAfD4/
EJ/PD8Tn8wPx+fxAfD4/EJ/PD8QPxOfzA/H5/EB8Pj8Qn88PxOfzA/H5/EB8Pj8Qn88PxOfz
A/H5fH4gPp8fiM/nB+Lz+YH4fH4gPp8fiM/nB+Lz+YH4fH4gPp8fiB+Iz+cH4vP5gfg+o6P8
QHw+PxCfzw/E5/MD8fn8QHw+PxCfzw/E5/MD8fn8QHw+PxCfz+cH4vP5gfh8fiA+nx+Iz+cH
4vP5gfh8fiA+nx+Iz+cH4vP5gfiB+Hx+ID6fH4jP5wfi8/mB+Hx+ID6fH4jP5wfi8/mB+Hx+
ID6fzw/E5/MD8fn8QHw+PxCfzw/E5/MD8fn8QHy+jgXi8/nu+wM79mpMjbRBXAAAAABJRU5E
rkJggg==' readStream) readStream) nextImage! !


!DoubleClickExample class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:26'!
descriptionForPartsBin
	^ self partName:	'DoubleClick' 
		categories:		#()
		documentation:	'An example of how to use double-click in moprhic' ! !


!EToyChatMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:26'!
descriptionForPartsBin

	^ self partName: 	'Text chat' 
		categories:		#()
		documentation:	'A tool for sending messages to other Squeak users' ! !


!EToyFridgeMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:26'!
descriptionForPartsBin

	^ self partName: 	'Fridge' 
		categories:		#()
		documentation:	'A tool for sending objects to other Squeak users' ! !


!EToyListenerMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 02:47'!
formerDescriptionForPartsBin
	"The code formerly in my #descriptionForPartsBin."

	^ self partName: 	'Listener' 
		categories:		#()
		documentation:	'A tool for receiving things from other Squeak users' ! !


!EToyMorphsWelcomeMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:27'!
descriptionForPartsBin

	^ self partName: 	'Welcome' 
		categories:		#()
		documentation:	'A sign that you accept morphs dropped directly into your world' ! !


!EToyMultiChatMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:27'!
descriptionForPartsBin

	^ self partName: 	'Text chat+' 
		categories:		#()
		documentation:	'A tool for sending messages to several Squeak users at once' 
		sampleImageForm: (Form
	extent: 25@25
	depth: 16
	fromArray: #( 1177640695 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 1593245696 1593263665 1593270007 1593270007 1593270007 1177634353 1177628012 1177628012 1177640695 1593270007 1593270007 1593278463 2147450879 1316159488 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593274233 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1731723264 1593257324 762064236 762064236 762064236 762064236 762057894 762057894 762064236 762064236 762064236 762064236 762064236 1177616384 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593278459 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 2147188731 1870200832 1593274233 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1870229369 1731723264)
	offset: 0@0)! !


!EToyProjectHistoryMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:27'!
descriptionForPartsBin
	^ self partName: 	'ProjectHistory' 
		categories:		#()
		documentation:	'A tool that lets you navigate back to recently-visited projects' ! !


!EToySenderMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:27'!
descriptionForPartsBin

	^ self partName: 	'Badge' 
		categories:		#()
		documentation:	'A tool for collaborating with other Squeak users' 
		sampleImageForm: (Form
	extent: 66@72
	depth: 16
	fromArray: #( 7175 1545042975 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082429975 470220800 470252575 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082413575 1545042975 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082429975 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 1582767304 1032871511 2134867775 2134842568 2134867775 2134867775 2134867775 1032879935 2134867775 2134867775 2134867775 2134867775 1582792511 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134842568 1032871511 1032863120 1582775696 1032871511 2134867775 2134867775 1032871511 2134842568 1032863120 482885008 1032879935 482901823 482885008 1032879935 1032863120 1032879935 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134850960 2134850960 1032879935 1032863120 2134850960 2134867775 2134859351 482876616 2134850960 2134867775 1032879935 1032879935 1032879935 1032879935 1032879935 1032863120 1582792511 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 1582767304 1032871511 1032863120 1582775696 1032871511 2134867775 2134842568 1582767304 1582767304 1582792511 482893399 482893399 482893399 482893399 482893399 1032863120 1582792511 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 1032863120 1032879935 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 65537 65537 65537 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134835201 65537 1032863120 1032863120 98111 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134835201 81296 2134867775 2134867775 1032847361 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134850960 1032879935 2134867775 2134867775 2134835201 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134835201 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 65537 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134835201 81296 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 65537 98111 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134835201 65537 1032879935 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 65537 81296 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 65537 1032879935 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134850960 81296 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134835201 1032879935 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134835201 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134850960 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134850960 1032879935 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134835201 98111 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134850960 1032879935 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141159423 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2141159231 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141159423 2147450879 2147450879 1039171583 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 1039171583 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2141159231 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141142512 1039154672 1593270007 1039163127 1593278463 1593261552 2147442423 1039154672 2147433968 1039154672 1593270007 1039163127 1593278463 1593261552 2147442423 1593270007 1593261552 2147450879 2147442423 1593270007 2147442423 1039171583 484990711 2141159231 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141150967 1039163127 1039171583 1039163127 1039171583 1039171583 1039154672 1039154672 1039163127 1039163127 1039171583 1039163127 1039171583 484982256 1039146216 1593270007 484982256 1039171583 2147425512 1593261552 2147425512 1039154672 1039171583 2141159231 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141159423 1039154672 1593278463 1039171583 1039171583 1039171583 1039154672 1039146216 1593278463 1039154672 1593278463 1039171583 1039171583 1039171583 1593261552 2147450879 1039171583 1593270007 2147433968 2147433968 2147433968 2147442423 1039171583 2141159231 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141159423 1593270007 2147450879 1039163127 1039163127 1593261552 2147442423 1039163127 2147450879 1593270007 2147450879 1039163127 1039163127 1593261552 2147433968 1593278463 1593261552 2147442423 2147433968 1593261552 1593270007 1039171583 2147442423 2141159231 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141159423 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2141159231 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141159423 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450783 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141150967 1039171583 1593261552 2147442423 1039171583 2147450879 2147442423 2147450879 1593278463 1593261552 2147450879 2147442423 1039171583 2147442423 2147450879 2147442423 1039171583 2147442423 2147450783 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141150967 2147433968 1039171583 1039154672 2147433968 2147450879 1593261552 2147442423 1039171583 1593278463 1039171583 2147433968 2147433968 1593261552 2147450879 2147442423 2147433968 1593261552 2147450783 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141159423 1039171583 1039171583 1039154672 1039154672 2147450879 2147433968 2147425512 484990711 2147433968 1593278463 2147433968 1039154672 2147433968 2147450879 2147450879 1039163127 484973800 1593278367 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141142512 2147442423 1039171583 1039171583 1593270007 1593278463 2147433968 2147450879 1039171583 2147450879 1039163127 2147450879 1593270007 2147433968 2147442423 2147450879 2147433968 2147433968 2147450783 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141142512 1039163127 1593261552 2147442423 1593278463 1593278463 1593261552 2147450879 1039163127 1593261552 2147442423 2147442423 1593278463 1593261552 2147442423 2147442423 1039171583 2147433968 1593278367 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2141159423 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450879 2147450783 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134861595 1391951679 2134867775 2134867775 2134856439 1729855295 2134867775 2134867775 1729849115 2134867775 2134867775 2134861595 1729855295 2134867775 2134867775 1729843959 1391951679 2134867775 2134867775 2134856439 1729855295 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 1326930843 1879001943 1729855295 2134861595 1398112251 1738035990 2134867775 2134855446 1536646039 1326874431 2134867775 1387357800 1718112945 2134867775 2134856463 1736736736 2145407816 1729855295 2134861595 1398243327 1738232599 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 1032863120 1032879935 2134867775 1032863120 1032879935 2134856439 1879011327 1879011327 1264025407 2134856533 2147188731 2147188731 1391951679 1391947770 1878683642 1878676215 2134856439 2120646246 2120646246 1391951679 1391951840 2145419232 2145419232 1397260095 2134856535 2147450879 2147450879 1391951679 2134867775 2082438175 2082438175 2134867775 2134842568 1507359 1514696 2134842568 48235488 48241864 2134854487 1391932912 904949759 1879003895 1391951867 484908263 1039040507 1398112063 1263890426 904753146 1878674261 2134856331 2120629539 1025736294 1384873791 1397260256 2145402336 2145419232 2145407735 1391951871 1039154672 1039171583 1398243135 2134867775 2082438175 2082438175 2134867775 2134835216 2031647 2031632 2134835680 65012704 65012192 2134854487 904949759 1879011327 1879003895 1391951867 2147171822 2147188731 1398112063 1263890426 904753146 1878674261 2134856331 2120646246 1025736294 1384873791 1397260256 1591754208 2145419232 2145407735 1391951871 1039163127 2147450879 1398243135 2134867775 2082438175 2082438175 2134867775 2134835216 2031647 2031632 2134835680 65012704 65012192 2134854487 904949759 1879011327 1879003895 1391951867 2147171822 2147188731 1398112063 1263890426 904753146 1878674261 2134856331 2120629539 2120646246 1384873791 1397260256 484449504 1591771104 2145407735 1391951871 2147442423 1593278463 1398243135 2134867775 2082438175 2082438175 2134867775 2134842568 1507359 1514696 2134842568 48235488 48241864 2134854487 1391932912 904949759 1879003895 1391951867 1593056487 2147188731 1398112063 1263890426 1391685626 1878674261 2134856331 2120637892 2120646246 1384873791 1397251808 484466400 484474848 2145407735 1391951871 484982256 1593278463 1398243135 2134867775 2082438175 2082438175 2134867775 2134867775 1032863120 1032879935 2134867775 1032863120 1032879935 2134855447 1879011327 1879011327 1536911131 1729849240 2147188731 2147188731 1393983295 1326870522 1878683642 1878675222 2134856369 2120646246 2120646246 1387364159 1393524704 2145419232 2145419232 1736730395 1729849243 2147450879 2147450879 1394048831 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134861595 1536913407 1879011327 1326939967 2134856470 2147188731 2147182488 1729855295 1729846167 1878683642 1536648987 2134861595 1718124134 2120640104 1729855295 1729849220 2145419232 2145419232 1393524543 2134856471 2147450879 2147444635 1729855295 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 1729842967 1264014071 2134867775 2134867775 1391940437 1393977115 2134867775 2134861595 1326862102 1729855295 2134867775 1729843889 1387357979 2134867775 2134861595 1393513288 1397248759 2134867775 2134867775 1391940439 1394042651 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 2082438175 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082438175 1545042975 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2134867775 2082429975 470252575 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082413575 7175 1545042975 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082438175 2082429975 470220800)
	offset: 0@0)! !


!EventRecorderMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 02:47'!
formerDescriptionForPartsBin
	"Answer  a description for use in a parts bin... formerly, that is."

	^ self partName: 'Event Recorder' 
		categories: {'Multimedia' }
		documentation: 'Lets you record and play back interactions' ! !


!EventRecordingSpace class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:28'!
descriptionForPartsBin
	"Answer a description for use in a parts bin."

	^ self partName:	'Event Theatre' 
		categories:		{'Multimedia' }
		documentation:	'A framework for creating tutorial snippets' ! !


!FreeCell class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:28'!
descriptionForPartsBin
	^ self partName:	'FreeCell' 
		categories:		{'Games' }
		documentation:	'A unique solitaire card game' ! !


!GraphMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:28'!
descriptionForPartsBin
	^ self partName:	'Graph' 
		categories:		#()
		documentation:	'A graph of numbers, normalized so the full range of values just fits my height.  I support a movable cursor that can be dragged with the mouse.' ! !


!InternalThreadNavigationMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:29'!
descriptionForPartsBin
	^ self partName: 	'ThreadNavigator' 
		categories:		{'Multimedia' }
		documentation:	'A tool that lets you navigate through a thread of projects.' ! !


!Mines class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:30'!
descriptionForPartsBin
	^ self partName: 	'Mines' 
		categories:		{'Games' }
		documentation:	'Find those mines' ! !


!MPEGMoviePlayerMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:30'!
descriptionForPartsBin
	^ self partName:	'MPEGPlayer' 
		categories:		{'Multimedia' }
		documentation:	'A player for MPEG and JPEG movies ' ! !


!NCButtonBar class methodsFor: 'instance creation' stamp: 'KR 7/31/2009 01:56'!
supplementaryPartsDescriptions

	| descriptions |
	descriptions := OrderedCollection withAll: {
		DescriptionForPartsBin
				formalName: 'ButtonBar' 
				categoryList: {'Connectors' }
				documentation: 'An empty buttonBar that you can add to' 
				globalReceiverSymbol: #NCButtonBar
				nativitySelector: #new.
	}.

	Preferences eToyFriendly ifFalse: [
		descriptions addAll: {
			DescriptionForPartsBin
				formalName: 'FSM ButtonBar' translatedNoop
				categoryList: #()
				documentation: 'A buttonBar for State Machine drawings' translatedNoop
				globalReceiverSymbol: #NCButtonBar
				nativitySelector: #newFSMToolbar.
			DescriptionForPartsBin
					formalName: 'Class ButtonBar' translatedNoop
					categoryList: #()
					documentation: 'A buttonBar for UML Class Diagrams' translatedNoop
					globalReceiverSymbol: #NCButtonBar
					nativitySelector: #newClassDiagramToolbar. 
		}.

		(Flaps respondsTo: #newFSMConnectorsFlap) ifTrue: [
			descriptions add: (
		(DescriptionForPartsBin
			formalName: 'FSM Flap' translatedNoop
			categoryList: #( )
			documentation: 'A pre-loaded Connectors flap for state machine drawings' translatedNoop
			globalReceiverSymbol: #Flaps
			nativitySelector: #newFSMConnectorsFlap) sampleImageForm: self fsmFlapImage; yourself) ].

		(Flaps respondsTo: #newClassDiagramConnectorsFlap) ifTrue: [
			descriptions add: (
		(DescriptionForPartsBin
			formalName: 'Class diagram Flap' translatedNoop
			categoryList: #( )
			documentation: 'A pre-loaded Connectors flap for UML class diagram drawings' translatedNoop
			globalReceiverSymbol: #Flaps
			nativitySelector: #newClassDiagramConnectorsFlap) sampleImageForm: self classDiagramFlapImage; yourself) ].
		].

	^descriptions.! !


!NCMakerButton class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:31'!
descriptionForPartsBin
	^ self partName:	'Maker Button' 
		categories:		{'Connectors' }
		documentation:	'A handy Morph-generating button' ! !


!NebraskaServerMorph class methodsFor: 'as yet unclassified' stamp: 'KR 7/31/2009 01:59'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'NebraskaServer' 
		categoryList: #()
		documentation: 'A button to start the Nebraska desktop sharing server' 
		globalReceiverSymbol: #NebraskaServerMorph
		nativitySelector: #serveWorldButton
	}! !


!NumericReadoutTile class methodsFor: 'instance creation' stamp: 'KR 7/31/2009 02:00'!
supplementaryPartsDescriptions
	"Answer additional items for the parts bin"

	Preferences universalTiles ifFalse: [^ #()].

	^ {DescriptionForPartsBin
		formalName: 'Number (fancy)' 
		categoryList: {'Basic' }
		documentation: 'A number readout for a Stack.  Shows current value.  Click and type the value.  Shift-click on title to edit.' 
		globalReceiverSymbol: #NumericReadoutTile
		nativitySelector: #authoringPrototype.

	   DescriptionForPartsBin
		formalName: 'Number (bare)' 
		categoryList: {'Basic' }
		documentation: 'A number readout for a Stack.  Shows current value.  Click and type the value.' 
		globalReceiverSymbol: #NumericReadoutTile
		nativitySelector: #simplePrototype.

	   DescriptionForPartsBin
		formalName: 'Number (mid)' 
		categoryList: {'Basic' }
		documentation: 'A number readout for a Stack.  Shows current value.  Click and type the value.' 
		globalReceiverSymbol: #NumericReadoutTile
		nativitySelector: #borderedPrototype}! !


!ObjectsTool class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:32'!
descriptionForPartsBin
	^ self partName:	'Objects' 
		categories:		#()
		documentation:	'A place to obtain many kinds of objects' ! !

!ObjectsTool class methodsFor: 'class initialization' stamp: 'KR 7/31/2009 12:28'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: ({#ObjectsTool.	 #newStandAlone. 'Object Catalog' . 'A tool that lets you browse the catalog of objects' } translatedNoopWithContext: 'PartDesc')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: ({#ObjectsTool	. #newStandAlone. 'Object Catalog' .'A tool that lets you browse the catalog of objects' } translatedNoopWithContext: 'PartDesc')
						forFlapNamed: 'Widgets'.]! !


!PianoKeyboardMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:32'!
descriptionForPartsBin
	^ self partName:	'PianoKeyboard' 
		categories:		{'Multimedia' }
		documentation:	'A piano keyboard' ! !


!RecordingControls class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:33'!
descriptionForPartsBin
	"If the receiver is a member of a class that would like to be represented in a parts bin, answer the name by which it should be known, and a documentation string to be provided, for example, as balloon help."

	^ self partName:	'SoundRecorder' 
		categories:		{'Multimedia' }
		documentation:	'A device for making sound recordings.' ! !


!RecordingControlsMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 02:47'!
formerDescriptionForPartsBin
	"Answer the former description of the original sound-recorder for the parts bin."

	^ self partName:	'SoundRecorder' 
		categories:		{'Multimedia' }
		documentation:	'A device for making sound recordings.' ! !


!RulerMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:33'!
descriptionForPartsBin
	^ self partName:	'Ruler' 
		categories:		#()
		documentation:	'A rectangle which continuously reports its size in pixels' ! !


!SameGame class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:33'!
descriptionForPartsBin
	^ self partName:	'Same' 
		categories:		{'Games' }
		documentation:	'A board game implementedby Tim Olson, based on a game originally written for UNIX by Eiji Fukumoto.' ! !


!ScorePlayerMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:33'!
descriptionForPartsBin
	^ self partName: 	'ScorePlayer' 
		categories:		{'Multimedia' }
		documentation:	' Mediates between a score such as a MIDIScore, a PianoRollScoreMorph, and the actual SoundPlayer synthesizer' ! !


!ScriptableButton class methodsFor: 'name' stamp: 'KR 7/31/2009 01:33'!
descriptionForPartsBin
	"Answer a description for use in bulding parts bins.  In latest take, this is not seen in any explicit category, but rather only in alphabetic or 'find' retrievals."

	^ self partName:	'Button' 
		categories:		{"'Scripting' translatedNoop. 'Basic' "}
		documentation:	'A button to use with tile scripting; its script will be a method of its containing playfield' ! !


!ScrollableField class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:33'!
descriptionForPartsBin
	"Info for build parts-bin entries."

	^ self partName:	'Scrolling Text' 
		categories:		#(Basic)
		documentation:	'A scrollable, editable body of text' ! !


!SimpleSliderMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:34'!
descriptionForPartsBin
	^ self partName:	'Slider' 
		categories:		{'Basic' }
		documentation:	'A scriptable control that allows you to choose a numeric value by dragging a knob.' ! !


!SoundLibraryTool class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:34'!
descriptionForPartsBin
	"Answer a description of the receiver for use in a parts bin"

	^ self partName:	'Sound Library' 
		categories:		{'Multimedia' }
		documentation:	'A tool for managing the sound library' ! !


!SpectrumAnalyzerMorph class methodsFor: 'as yet unclassified' stamp: 'KR 7/31/2009 01:34'!
descriptionForPartsBin
	^ self
		partName: 'Spectrum Analyzer' 
		categories: {'Multimedia' }
		documentation: 'A device for analyzing sound input' 
! !


!StackMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 02:48'!
formerDescriptionForPartsBin
	^ self partName:	'Stack' 
		categories:		#()
		documentation:	'A database of any sort -- slide show, rolodex, and any point in between' ! !


!StarMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:34'!
descriptionForPartsBin
	^ self partName:	'Star' 
		categories:		{'Graphics' }
		documentation:	'A symmetrical polygon in the shape of a star'  ! !


!StickyPadMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:34'!
descriptionForPartsBin
	"Answer a description of the receiver for use in a parts bin"

	^ self partName: 	'Sticky Pad' 
		categories:		{'Just for Fun' }
		documentation:	'A translucent, borderless rectangle of a standard size, delivered in a predictable sequence of pastel colors' 
		sampleImageForm: (Form extent: 50@40 depth: 16
	fromArray: #( 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461414680 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461414680 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461414680 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521903284 1723098804 1723098804 1723096921 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521903284 1723098804 1723098804 1723096921 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521903284 1723098804 1723098804 1723096921 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322274512 1322275535 1389318863 1389318863 1389317938 1328697138 1328697138 1328702226 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322274512 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322275535 1389318863 1389318863 1389317938 1328697138 1328697138 1328702226 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322275535 1389318863 1389318863 1389317938 1328697138 1328697138 1328702226 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1389318863 1389318863 1389318863 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521903284 1389318863 1389318863 1389317938 1460426508 1460426508 1460429548 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1723098804 1389318863 1389318863 1328697138 1460426508 1460426508 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521903284 1723098804 1389318863 1389317938 1328697138 1460426508 1460429548 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1723098804 1723098804 1389318863 1328697138 1328697138 1460426508 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521903284 1723098804 1723098804 1389317938 1328697138 1328697138 1460429548 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1723098804 1723098804 1723098804 1328697138 1328697138 1328697138 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461414680 1723098804 1723098804 1723096921 1328697138 1328697138 1328702226 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1796762392 1723098804 1723098804 1599692633 1328697138 1328697138 1662149394 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461414680 1796762392 1723098804 1723096921 1599692633 1328697138 1328702226 1662149394 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1796762392 1796762392 1723098804 1599692633 1599692633 1328697138 1662149394 1662149394 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461414680 1796762392 1796762392 1723096921 1599692633 1599692633 1328702226 1662149394 1662149394 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741)
	offset: 0@0)! !


!StoryboardBookMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:35'!
descriptionForPartsBin
	^ self partName:	'Storyboard' 
		categories:		#()
		documentation:	'A storyboard authoring tool' ! !


!SugarNavigatorBar class methodsFor: 'utilitity' stamp: 'KR 7/31/2009 02:01'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'File Dialog' 
		categoryList: #('Scripting')
		documentation: 'The list of files and directories' 
		globalReceiverSymbol: #SugarNavigatorBar
		nativitySelector: #findAnythingMorph
	}! !


!TestRunner class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:35'!
descriptionForPartsBin
	^self partName: 'Test Runner' 
		categories: #()
		documentation: 'SUnit Test UI' 
! !


!Tetris class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:35'!
descriptionForPartsBin
	^ self partName:	'Tetris' 
		categories:		#()
		documentation:	'Tetris, yes Tetris' ! !


!TextMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 02:01'!
supplementaryPartsDescriptions
	"Answer a list of DescriptionForPartsBin objects that characterize objects that this class wishes to contribute to Stationery bins *other* than by the standard default #newStandAlone protocol"

	^ {
	DescriptionForPartsBin
		formalName: 'Text (border)' 
		categoryList: #()
		documentation: 'A text field with border' 
		globalReceiverSymbol: #TextMorph
		nativitySelector: #borderedPrototype.

"	DescriptionForPartsBin
		formalName: 'Text (fancy)' translatedNoop
		categoryList: {'Text' translatedNoop}
		documentation: 'A text field with a rounded shadowed border, with a fancy font.' translatedNoop
		globalReceiverSymbol: #TextMorph
		nativitySelector: #fancyPrototype."

	DescriptionForPartsBin
		formalName: 'Text' translatedNoop
		categoryList: {'Basic' translatedNoop}
		documentation: 
			'A raw piece of text which you can edit into anything you want' translatedNoop
		globalReceiverSymbol: #TextMorph
		nativitySelector: #nonwrappingPrototype.
}
! !


!ClipboardMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:25'!
descriptionForPartsBin
	^ self partName:	'Clipboard' 
		categories:		#()
		documentation:	'This object will always show whatever is on the text clipboard' ! !


!NCDisplayTextMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:57'!
supplementaryPartsDescriptions
	^{
	(DescriptionForPartsBin
		formalName: 'Enhanced Text' 
		categoryList: {'Connectors' }
		documentation: 'A raw piece of text (with a context menu) which you can edit into anything you want' 
		globalReceiverSymbol: #NCDisplayTextMorph
		nativitySelector: #authoringPrototype) sampleImageForm: (self authoringPrototype imageFormDepth: 32); yourself.
	}
! !


!NCGrabbableDisplayTextMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:58'!
supplementaryPartsDescriptions
	^{
	DescriptionForPartsBin
		formalName: 'Title' 
		categoryList: {'Connectors' }
		documentation: 'Text that you can grab and move around (click to edit)' 
		globalReceiverSymbol: #NCGrabbableDisplayTextMorph
		nativitySelector: #authoringPrototype.
	}
! !


!TrashCanMorph class methodsFor: 'miscellaneous' stamp: 'KR 7/31/2009 01:35'!
descriptionForPartsBin
	^ self partName:	'Trash' 
		categories:		{ 'Basic' }
		documentation:	'a tool for discarding objects' 
		sampleImageForm: (Form extent: 42@54 depth: 8 fromArray: #( 0 0 0 2555943 992034 555814414 587202599 654311424 0 0 0 0 0 654320418 550751400 2829625512 2829625512 2829625357 556007424 0 0 0 0 36 3553874600 2829155709 2105376125 2711726248 2829625512 2728926240 587212583 0 0 0 639882194 3433594237 1400339837 2107746472 2812848296 2829634764 2829623677 2820612864 640090112 0 0 3553809064 2097828727 2108216018 3537030348 3436367016 2829625548 3537021096 2105452577 603989760 0 9427 3537019218 22259922 4141011666 3536637138 4160212129 2712183208 2832398034 2709355944 539103014 0 2413266 3531411713 2110979575 3537031884 3435975671 4157384573 2812846461 2108216055 3430776189 488645135 654311424 651416310 2823946621 4160606930 3537030348 3539466451 2829559720 2829625506 2105398007 3534257533 2718769186 0 601019090 2097238994 4258452178 3537031891 4160213671 2812782760 2829559976 2105387218 4154948989 2099055886 254214144 4174566098 1392595922 4258452178 3537041442 3551045799 2829625512 2829625505 2105396471 3534257533 2098863648 606470144 4275229394 2097238696 4260811474 3536977959 3550980264 2829625512 2829558141 2108225271 2826796413 1998134560 589758464 584241874 3427991891 3438727890 3537031970 3433614504 2829625512 2829164961 3436377804 2709355901 1394154783 589692928 617861842 3534246674 1403572946 3537031890 3536627880 2829625512 2812848338 4157778045 2105376083 1394154527 587202560 265540306 3537030269 1397980584 2831994060 3435964584 2829625512 2831995602 3433594237 2105365330 1394154783 589758464 13871314 3537041106 2826796413 2105385640 2829559976 2829625548 3436367016 2709355901 1397902346 1394220320 606535680 639674536 2831995602 3537030312 2829625256 2829625512 2829634728 2829625469 2105365331 1280463699 186260768 606535680 1037224 2829625512 3436368594 3537030348 3433605288 2829625512 2709355895 1397967954 1376389715 404364814 254214144 9164 2829625512 2829166760 2829625512 2829625505 2709355901 1397951058 1280463370 173167480 421203235 637534208 35 2829625511 2711715197 2105376125 2105376119 1397969747 1397903954 168430156 1397954174 421339392 654311424 0 4174162088 2728492413 2105376125 2105374547 1397969747 1397969490 1280070483 2105350169 438182694 0 0 267898023 2829155709 2105376125 2104981331 1397969747 1397902346 1397979005 2105376282 455025703 0 0 16241320 2832387239 2105376125 2004318035 1397969747 1397980541 2104982910 2105350427 471928576 0 0 653775528 2832388812 2712119464 2829221245 2728960381 2105387170 2104982910 2105350683 488701990 0 0 16700071 2832388818 2829625548 3433603489 2829625469 2105387170 2104982909 2105350683 504233984 0 0 2413224 2815218380 2829559976 3433594237 2829625469 2105387176 2104982910 2105416476 220266496 0 0 2413516 2815218386 2812782760 2829614461 2829625469 2105387176 2104982909 2105416476 220341760 0 0 2413516 2815218386 2829166796 2829623677 2829625469 2105387176 2104982909 2105416733 522397440 0 0 54226 2829636306 2810030284 3433605245 2829625469 2105385640 2104982910 2105416733 522397440 0 0 2619346 2829636306 2829166760 2829625469 2829625505 2105385634 2104982945 2097945629 522462976 0 0 65234 2812859090 2829166760 3433604989 2829625469 2105387176 2104982945 2097945629 539240192 0 0 8914 2829636306 2829166760 3433605245 2829625505 2105387176 2104982945 2098797853 537863936 0 0 9427 2829634770 3433539752 3433604989 2829625505 2105387176 2104982946 2098797597 554641152 0 0 211 3433549010 3433146536 3433605245 2728962209 2105387176 2104983208 2098863389 553658112 0 0 9975 3433539794 3433144744 2829625213 2728962209 2105387176 2104983208 2098863134 234881024 0 0 10238 3433539794 3534201256 3435964321 2712184993 2105387176 2104983202 2115640350 234891008 0 0 35 3534203090 3534266792 3435964577 2108205217 2105387176 2104982946 2115705886 234881024 0 0 36 3550980306 3534268328 2831984801 2108205223 2105385640 2104982946 2115706142 570425344 0 0 0 3551045836 3534266792 2831984801 2108205224 2105385640 2105376161 2115705869 572915712 0 0 38 4155025356 3534266792 2831984801 2108205224 2105385640 2105376161 2115706125 572915712 0 0 39 4174162088 3536626088 2831984801 2108205224 2105385640 2105376126 2115771661 589758464 0 0 0 583837608 3536626087 2831984801 2108205224 2105387176 2105376161 2115771679 589692928 0 0 0 601006503 3537020839 2831984807 2108205224 2102623656 2105385342 2719751456 254214144 0 0 0 617850792 3537020833 2831984808 2108214440 2097238952 2105387170 438111502 0 0 0 0 668191948 3537021095 2829634727 2108205224 2097238952 2726142590 471736591 654311424 0 0 0 2282194 3537020833 2829634728 2711726248 2097238690 2826796314 220275750 0 0 0 0 63442 3537021095 2832387240 2107746472 2709355937 2105350686 539168550 640090112 0 0 0 211 3537030312 3536627879 2712194216 2815677352 2820414989 555885347 588195584 0 0 0 39 584307410 3433605288 2812848295 2714576126 3542093084 504176397 521015079 0 0 0 0 8992 3553414312 2829625512 2820673060 3553470632 2829589020 488579879 0 0 0 0 39 991758 235807524 2564819 3433605288 2829614621 220270375 0 0 0 0 0 0 0 2140364 3536627880 2709356064 571418112 0 0 0 0 0 0 0 581478568 3433605246 2719813120 640090112 0 0 0 0 0 0 0 13880488 2829589793 603989798 0 0 0 0 0 0 0 0 991758 570435111 654311424 0 0) offset: 0@0)! !


!TTSampleStringMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:35'!
descriptionForPartsBin
	^ self partName:	'TrueType banner' 
		categories:		#()
		documentation:	'A short text in a beautiful font.  Use the resize handle to change size.' ! !


!UndefinedObject methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:35'!
descriptionForPartsBin
	"Answer a description of this class for the parts bin."

	^ self partName:	'ClipboardText' 
		categories:		#()
		documentation:	'This object will always show whatever is on the text clipboard, in a scrollable pane.' ! !


!VideoMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:35'!
descriptionForPartsBin
	^ self
		partName: 'Camera' 
		categories: {'Multimedia' }
		documentation: 'A player for video devices like cameras, video capturers, etc.' 

! !


!WatchMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:36'!
descriptionForPartsBin
	"Answer a description for use in parts bins."

	^ self partName:	'Clock' 
		categories:		#('Just for Fun')
		documentation:	'An analog clock face' ! !


!WaveEditor class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:36'!
descriptionForPartsBin
	^ self partName:	'WaveEditor' 
		categories:		{'Multimedia' }
		documentation:	'A workbench for seing and editing wave forms' ! !


!WsPhonePadMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:36'!
descriptionForPartsBin
	^ self
		partName: 'PhonePad' 
		categories: {'Multimedia' }
		documentation: 'A device for dialing by tone.' ! !


!WsWorldStethoscopeMorph class methodsFor: 'parts bin' stamp: 'KR 7/31/2009 01:36'!
descriptionForPartsBin
	^ self
		partName: 'WorldStethoscope' 
		categories: {'Multimedia'  }
		documentation: 'A device for analyzing phenomena as sounds' 
! !

GetTextExporter2 removeSelector: #appendPartsDesciption:!
GetTextExporter2 removeSelector: #listPartsDescription!
