'From etoys4.0 of 9 October 2008 [latest update: #2237] on 4 August 2009 at 12:32:29 am'!
"Change Set:		transNopCtx-KR
Date:			29 July 2009
Author:			Korakurider

#translatedWithCtx: and #translatedNoopWithCtx: ,
variant of #translated and #translatedNoop with manually specified msgctxt"!


!Object methodsFor: 'translating' stamp: 'KR 6/25/2009 14:21'!
translatedNoopWithContext: aContext
	"variant of #translatedNoop with translation context"! !


!Array methodsFor: 'translating' stamp: 'KR 6/25/2009 14:21'!
translatedNoopWithContext: aContext
	"variant of #translatedNoop with translation context"
	^self! !


!GetTextExporter2 methodsFor: 'exporting' stamp: 'KR 7/31/2009 02:17'!
appendTranslations: domains 
	self appendStringReceivers: #translated into: domains.
	self appendStringReceivers: #translatedNoop into: domains.
	self appendStringReceiversAndContext: #translatedWithContext: into: domains.
	self appendStringReceiversAndContext: #translatedNoopWithContext: into: domains.
	self appendVocabularies: domains.
	self appendPartDesciptions: domains.
! !

!GetTextExporter2 methodsFor: 'private' stamp: 'KR 7/23/2009 01:03'!
appendStringReceiversAndContext: aSymbol into: domains
	| literals references domainName methodReference touples found contexts msgctxt literal |
	
	found := TranslatedReceiverFinder new stringReceiversWithContext2: aSymbol.
	found do: [ :assoc |
		methodReference := assoc key.
		touples := assoc value.
		domainName _ self getTextDomainForClassCategory:
			(Smalltalk at: methodReference classSymbol) category.
		literals _ domains at: domainName ifAbsentPut: [Dictionary new].
		touples do: [ :touple |
			literal _ touple at: 1.
			msgctxt _ touple at: 2.
			contexts _ literals at: literal ifAbsentPut: [Dictionary new].
			references _ contexts at: msgctxt ifAbsentPut: [OrderedCollection new].
			references add: methodReference.
		].
	]. 
! !


!String methodsFor: 'translating' stamp: 'KR 7/29/2009 12:45'!
translatedNoopWithContext: aString
	"variant of #translatedNoop with translation context"
	^self! !

!String methodsFor: 'translating' stamp: 'KR 7/29/2009 12:46'!
translatedWithContext: aString
	"answer the receiver translated to the default language"

	| domain here |
	here _ thisContext sender receiver class.
	here == Text ifTrue: [here _ thisContext sender sender receiver class].	"ignore super call"
	domain := TextDomainManager domainForClass: here.

	^ self translatedTo: LocaleID current inDomain: domain withContext: aString! !


!TranslatedReceiverFinder methodsFor: 'accessing' stamp: 'KR 7/23/2009 00:48'!
findWordsAndContextWith: aSymbol in: aMethodReference 
	"Find words for translation with the symbol in a method. See
	LanguageEditorTest >>testFindTranslatedWords"
	"| message | 
	message := MethodReference new setStandardClass: Morph class
	methodSymbol: #supplementaryPartsDescriptions.
	self new findWordsWIth: #translatedNoop in: message"
	| messages keywords aParseNode msgctxt |
	aParseNode := aMethodReference decompile.
	"Find from string literal"
	messages := Set new.
	self
		search: aSymbol
		messageNode: aParseNode
		addTo: messages.
	keywords := OrderedCollection new.
	messages
		select: [:aMessageNode | aMessageNode receiver isMemberOf: LiteralNode]
		thenDo: [:aMessageNode |
				msgctxt := (aMessageNode arguments at: 1) key.
				aMessageNode receiver key
				literalStringsDo: [:literal | 
					keywords add: (Array
									with: literal
									with: msgctxt).
				]
		].
	"Find from array literal"
	"self
		arraySearch: aSymbol
		messageNode: aParseNode
		addTo: keywords."
	^ keywords! !

!TranslatedReceiverFinder methodsFor: 'accessing' stamp: 'KR 7/23/2009 00:41'!
findWordsWith: aSymbol in: aMethodReference 
	"Find words for translation with the symbol in a method. See
	LanguageEditorTest >>testFindTranslatedWords"
	"| message | 
	message := MethodReference new setStandardClass: Morph class
	methodSymbol: #supplementaryPartsDescriptions.
	self new findWordsWIth: #translatedNoop in: message"
	| messages keywords aParseNode |
	aParseNode := aMethodReference decompile.
	"Find from string literal"
	messages := Set new.
	self
		search: aSymbol
		messageNode: aParseNode
		addTo: messages.
	keywords := OrderedCollection new.
	messages
		select: [:aMessageNode | aMessageNode receiver isMemberOf: LiteralNode]
		thenDo: [:aMessageNode | aMessageNode receiver key
				literalStringsDo: [:literal | keywords add: literal]].
	"Find from array literal"
	self
		arraySearch: aSymbol
		messageNode: aParseNode
		addTo: keywords.
	^ keywords! !

!TranslatedReceiverFinder methodsFor: 'accessing' stamp: 'KR 7/23/2009 00:52'!
stringReceiversWithContext2: aSymbol
	"Find string receivers for a symbol.
	Answer a collection of aMethodReference -> {keyword. keyword...}"
	"self new stringReceiversWithContext: #translated"
	| keywords methodReferences |
	methodReferences _ SystemNavigation default allCallsOn: aSymbol.
	^ methodReferences inject: OrderedCollection new into: [:list :next |
		keywords := self findWordsAndContextWith: aSymbol in: next.
		keywords
			ifNotEmpty: [list add: next -> keywords].
		list]
! !

