'From etoys4.0 of 9 October 2008 [latest update: #2237] on 4 August 2009 at 12:32:19 am'!
"Change Set:		transCtxSelector-KR
Date:			29 July 2009
Author:			Korakurider

To use selector name of method that sender of #translated and #translatedNoop as msgctxt"!


!GetTextExporter2 methodsFor: 'private' stamp: 'KR 7/22/2009 18:01'!
appendStringReceivers: aSymbol into: domains
	| literals references domainName methodReference keywords found contexts msgctxt |
	
	found := TranslatedReceiverFinder new stringReceiversWithContext: aSymbol.
	found do: [ :assoc |
		methodReference := assoc key.
		keywords := assoc value.
		domainName _ self getTextDomainForClassCategory:
			(Smalltalk at: methodReference classSymbol) category.
		literals _ domains at: domainName ifAbsentPut: [Dictionary new].
		keywords do: [ :literal |
			contexts _ literals at: literal ifAbsentPut: [Dictionary new].
			msgctxt _ methodReference methodSymbol asString.
			references _ contexts at: msgctxt ifAbsentPut: [OrderedCollection new].
			references add: methodReference.
		].
	]. 
! !

!GetTextExporter2 methodsFor: 'private' stamp: 'KR 7/29/2009 23:21'!
appendVocabularies: domains
	| literalsForDomain contexts references domainName |
	
	EToyVocabulary allPhrasesWithContextToTranslate do: [ :r |
		domainName _ self getTextDomainForClassCategory: r first.
		literalsForDomain _ domains at: domainName ifAbsentPut: [Dictionary new].
		r fourth do: [ :tuple |
			| literal msgctxt |
			literal _ tuple first.
			msgctxt _ tuple second.
			contexts _ literalsForDomain at: literal ifAbsentPut: [Dictionary new].
			references _ contexts  at: msgctxt ifAbsentPut: [OrderedCollection new].
			references add: (MethodReference new setStandardClass: (r second)
													methodSymbol: (r third)).
		].
	]. 
	! !

!GetTextExporter2 methodsFor: 'private' stamp: 'KR 6/25/2009 17:26'!
exportPhrase: phraseString context: contextString translation: translationString 
	| normalizedTrans tmp transStartsWithCR transEndsWithCR|
	phraseString isEmpty
		ifTrue: [^ self].
	self exportTag: 'msgctxt' msg: contextString.
	self exportTag: 'msgid' msg: phraseString.
	translationString size = 0 ifTrue: [
		normalizedTrans _ ''
	] ifFalse: [
		transEndsWithCR _ translationString last = (Character cr).
		phraseString last = (Character cr) ifTrue: [
			transEndsWithCR ifTrue: [
				normalizedTrans _ translationString
			] ifFalse: [
				normalizedTrans _  translationString , String cr
			]
		] ifFalse: [
			transEndsWithCR ifTrue: [
				normalizedTrans _ translationString allButLast
			] ifFalse: [
				normalizedTrans _ translationString
			]
		].
		transStartsWithCR _ normalizedTrans first = (Character cr).
		phraseString first = (Character cr) ifTrue: [
			transStartsWithCR ifFalse: [
				tmp _ (Character cr asString) , normalizedTrans.
				normalizedTrans _ tmp.
			]
		] ifFalse: [
			transStartsWithCR ifTrue: [
				normalizedTrans _ normalizedTrans allButFirst
			]
		]
	].
	self exportTag: 'msgstr' msg: normalizedTrans.
	stream cr! !

!GetTextExporter2 methodsFor: 'private' stamp: 'KR 7/22/2009 18:42'!
export: literals translator: translator domain: domainName 
	| fileName |
	"Export a gettext file in a category. literals is a dictionary of keyword -> #(MethodReference...) in the textDomain."
	fileName := self dirNameDomain: domainName translator: translator.
	[stream := FileStream forceNewFileNamed: fileName.
	stream lineEndConvention: #lf.
	stream converter: UTF8TextConverter new.
	self exportHeader: domainName.
	self exportInformation: self createExtraInformation.
	self exportBody: literals translator: translator]
		ensure: [stream close]! !

!GetTextExporter2 methodsFor: 'file out' stamp: 'KR 7/22/2009 18:42'!
exportBody: literals translator: translator 
	"Export a gettext file body. literals is a dictionary of keyword ->
	#(MethodReference...) in the textDomain."
	"Build quadruplet{sortKey. comment. msgid. msgctxt} to optimize sorting (getting category is
	too slow).
	If there are two or more methods for a mgsid, only first method
	(alphabetical) is used for sorting."
	| sorted msgid contexts msgctxt references category sortKey comment quadruplets commentUnderLined |

	quadruplets _ OrderedCollection new.
	literals associations do: [:literalAssoc |
		msgid _ literalAssoc key.
		contexts _ literalAssoc value.
		contexts associations do: [:ctxAssoc |
			msgctxt _ ctxAssoc key.
			references _ ctxAssoc value.
			category _ (Smalltalk at: references first classSymbol) category asString.
			sortKey _ msgctxt , ',' , msgid.
			comment _ category. 
			references do: [:methodRef |
				comment _ comment , ',', methodRef actualClass asString.
			].
			"Replace white spaces to _ because gettext tool might
			replace a space to a new line some times, and it makes
			difficult to take a diff."
			commentUnderLined := comment copyReplaceAll: ' ' with: '_'.

			quadruplets add: (Array
					with: sortKey
					with: commentUnderLined
					with: msgid
					with: msgctxt).
		]
	].

	"Sort and output the words"
	sorted _ quadruplets asArray
				sort: [:a :b | a first <= b first].
	sorted
		do: [:quadruplet | 
			comment := quadruplet second.
			msgid := quadruplet third.
			msgctxt := quadruplet fourth.
			self exportRecordHeader: comment.
			self
				exportPhrase: msgid
				context: msgctxt
				translation: (self translationFor: msgid in: translator).
		].! !


!String methodsFor: 'translating' stamp: 'KR 7/21/2009 11:09'!
translated
	"answer the receiver translated to the default language"

	| domain here sel mcls|
	here _ thisContext sender receiver class.
	here == Text ifTrue: [here _ thisContext sender sender receiver class].	"ignore super call"
	domain := TextDomainManager domainForClass: here.

	sel := thisContext sender receiver class
				selectorAtMethod: thisContext sender method
				setClass: [:c | mcls := c].

	^ self translatedTo: LocaleID current inDomain: domain withContext: sel asString! !

